#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#ifdef SGI
        #include <gl/image.h>
        #include <sys/types.h>
        #include <malloc.h>
	#define SGIIMAGE
#endif
#ifdef LIBIMG
        #include <image.h>
	#define SGIIMAGE
#endif
#ifdef LOGISCAN
	#include <fcntl.h>
	#include <sys/time.h>
	#include <unistd.h>
	#include <sys/ioctl.h>
	#include <scanner.h>
	struct modeinfo_struct mi;
	int scan_graylevels;
	unsigned char *scan_buf;
	fd_set rfds;
	struct timeval tv;
	#define SCAN_WAIT 1
	int scan_fd;
	int inches;
#endif
#define pi 3.14159

/* FRAMEx by Tom Shield */

/* variable image size version of FRAMEx */

/* last modified 2/24/94  work on cannot continue problem (didn't find a bug)
                3/3/94 added contents display
                3/4/94 added 3 chan SGI file write
                3/7/94 added color map to 3 channel sgi write
                3/17/94 increased malloc'ed size for ximage data in redraw
                3/24/94 fixed histogram, and other details
                9/12/94 added 24 bit section to redraw
                9/14/94 added quicksave and both windows keypress
                         changed to global imagedata -- didn't help trace problem
                9/15/94  used lint -- found bug if(exit = 1) in trace routines.
                9/16/94 trace/crash problem due to useing XDestroyImage which also
                                freed the imagedata memory
                11/19/95 defined SVIDEO for SGI file support under DVX
                09/07/96 added level filter
                11/20/96 first Linux compile -- added -DDVX define 
                         compile in Linux with -DMSDOS for correct endian
                11/26/96 added PBM file read support
		02/15/97 added LIBIMG define
		02/21/97 added logiscan grayscale input -DLOGISCAN
		02/22/97 moved point and click menus from framem.c
			 changed MSDOS to INTEL defines
			 cleaned up logiscan support
		02/23/97 added ioctl buffer len set for scan -- caused crash.

*/

/*
     start of code for x-windows systems

     SGI version only: reads/writes sgi RBG files: reads/writes rgb and b/w
                         but sgi are converted to gray scale internally

     compile with gnu gcc compiler: -lgutil -limage -lx11 -lm

     use -DINTEL for compile on INTEL cpus

     use -DSGI for compile on SGI systems w/ libgutil and libimage

        needs shared lib's on SGI (Irix 4.05 and earlier only):

                -lsvideo -lgutil -limage -lX11_s -lm -lc_s


     menu defined in set_buttons for second window

     needs the following modifications:
                                        output LUT settings: r/w color cells
                                        pixel line outputs/screen graph etc

                                        mouse menus for all operations

                                        should have separate compiler define for svideo

                                        should use YUV frame grab as in slowmovie


*/

/* X include files */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#ifdef DVX
    #include <X11/cursorfo.h>
#else
    #include <X11/cursorfont.h>
#endif

#ifdef SVIDEO
        #include <svideo.h>     /* must be included after <X11/Xlib.h> */
#endif

/* declarations */
char title[50];

/* general X declarations */
Display *mydisplay;
XEvent myevent;
KeySym mykey;
int myscreen;
unsigned long myforeground, mybackground;
Colormap mycolormap;
Cursor mycursor;
XColor mycolor_def;
XColor mycolor_rgb;
Font myfont;

/* for the main image window */

Window mywindow;
Window root;
GC mygc;
XSizeHints myhint;
XWMHints *mywmhint = NULL;
XClassHint *myclasshint = NULL;
XTextProperty mytitle;
XImage *myimage;

/* declarations for second window (menu) */

Window my2window;
GC my2gc;
XSizeHints my2hint;
XClassHint *my2classhint = NULL;  /* needed for R4 call */
XWMHints *my2wmhint = NULL;
XTextProperty my2title;
int w2xsize,w2ysize;

struct Button
{
        int x;   /* location of center of each button */
        int y;   /* ditto */
        char text[20]; /* button text */
} buttons[10];


struct Menu
{
        unsigned int width;  /* width of each button */
        unsigned int height; /* height of each button */
        int num_buttons;   /* number of buttons */
} menu1;

int fheight=13;       /* should get these from x font */
int fwidth=8;         /* set for 8x13 font picked below */

char question[50];

/*  for frame subroutines */

int i;
char text[10];
int done;
unsigned char *imagedata;  /* for myimage, has to be global */

FILE *fileprt;
char file[100];
char contents[2][100];  /* filename of the contents of buffer 0/1 */
int cmdline=0;  /* is there a filename on the cmdline? 1=yes */

int width=512;  /* size of the image default is 512x480 */
int height=480;
/*
unsigned char image[2][480][512];   actual image data -- old storage method
*/
unsigned char *imagebuff; /* have to malloc the space */

/* function prototype for getting data from the image buffer */
unsigned char image(int buffer,int row, int col);

int disbuf=0;  /* which image to use 0 or 1 */

unsigned int xsize,ysize;
unsigned int line_width,border_width,depth;
int line_style,cap_style,join_style;
int newimage=2;
int show_pos=0;
int auto_draw=1;   /* do we automatically redraw the image 1=yes */
unsigned long lut[256];
unsigned long color_pix;  /* for overlay tracing lines */
char color_pix_name[]={"orange red"};

/*  for gffile subroutines */

int invec[5005];         /* for traced data points */
int xp[5005],yp[5005];
float zp[5005];          /* fringe number */
int max_pts = 5000;

/* for trace routine */

int trace( );
int old_pts=0;
int max_row = -1;    /* should set these based on image size */
int min_row = -1;
int max_col = -1;
int min_col = -1;
int freq_pts = 10;
int start_row=-1;
int start_col=-1;
int end_row=256;
int end_col=256;
int bin_lev=0;
float last_fringe = 999.0;
float fringe;       /* current fringe for trace */
float step_fringe;
int use_end_pt=0;
int dir_index_set = -1;
int usr_lut[256];          /* for binary display -- set with def_olut */
int mark_row=-1;
int mark_col;

/* for the smoothing and math routines */

int target,source,run_sum;
int window,brush;


/* for edit */

int brush=1;  /* default to 3 pix wide brush */
int brush_level=255;

/* for SV grab routine */

int grab_on = 0;         /* = 1 means set for grabing: -g option */

/* for logiscan routines */

int scan = 0; /* =1 means set for scanner -s n option */

main(argc,argv)
int argc;
char **argv;
{

extern int    optind;
extern char   *optarg;
char  *cmd;
char  *display = NULL;
int   c;
char *geo = NULL;
char defgeo2[30];
/* filled below
char *defgeo = "512x480+200+100";
*/
char *defgeo;
unsigned int bw = 2;  /* border width */
int x,y,xwidth,xheight;
char hostname[50], temp[50];
int hostlen=50;
char *titleptr;
int row,col,pix;
int q=-1;
long isize,size;

  cmd = argv[0];
#ifdef SVIDEO
  while ((c = getopt(argc, argv, "ud:h:w:n:g")) != EOF)
#else
  #ifdef LOGISCAN
     while ((c = getopt(argc, argv, "ud:h:w:n:s:")) != EOF)
  #else
     while ((c = getopt(argc, argv, "ud:h:w:n:")) != EOF)
  #endif
#endif
    switch(c)   {

    case 'w':  /* image width */
       width = atoi(optarg);
       if(width < 1) width = 512;
       break;

     case 'h':  /* image height */
        height = atoi(optarg);
        if(height < 1 ) height = 480;
        break;

     case 'n':   /* 'new' start with blank image */
        newimage = -1;
        pix = atoi(optarg);   /* the fill pixel value 0-255 */
        if( pix < 0 || pix > 255 ) pix = 0;
        break;

#ifdef SVIDEO
     case 'g':  /* set up to grab frames */
        width = SV_NTSC_XMAX;
        height = SV_NTSC_YMAX;
        newimage = -1;
        grab_on = 1;
        break;
#endif

#ifdef LOGISCAN
	case 's': /* use scanner, input n inches vertically */
		inches = atoi(optarg);
		newimage = -1; /* donot read in a file */
		pix = 255;
		scan = 1;
		break;
#endif		

    case 'd':   /* set x windows display */
      display = optarg;
      break;

    default:
    case 'u':  /* usage */
      usage(cmd);
      exit(0);
    }


/* get command line file name if there */

    if( optind < argc )
    {
        strcpy(file,argv[optind]);
        cmdline=1;
    }

    strcpy(contents[0],"empty");
    strcpy(contents[1],"empty");
    
#ifdef LOGISCAN
	if(scan == 1)
	{
		setup_scanner();
		if(inches > 0)
			height = inches*mi.ydpi;
		else
		{
			inches = 1;
			height = mi.ydpi;
		}
	}
#endif	

/*  alloc image buffer memory */

        isize = (long) 2*(width+1)*(height+1);  /* add some extra to make sure */

        imagebuff = (unsigned char*) malloc((size_t) isize);

        if (imagebuff == NULL )
        {
                printf("Unable to allocate image buffer \n");
                exit(0);
        }

/*      get file input if newimage = 2 */

        if(newimage == 2)
        {
            if(read_both() == -1 ) exit(0);
        }
         else
        {

                blank(pix);
        }

        newimage=1;  /* actually read_both sets this too ... */

        printf("image width = %i height = %i \n",width,height);

/* set the gemetry for the window ... read_both might change it */

     sprintf(defgeo2,"%ix%i+200+150",width,height);
     defgeo=defgeo2;

/* now open the display after file is ok */

  if ((mydisplay = XOpenDisplay(display)) == NULL)
  {
    fprintf(stderr, "Can\'t open display: %s\n", display );
    exit(0);
  }

/* initialization of X window */

        myscreen = DefaultScreen(mydisplay);

        XGeometry (mydisplay, myscreen, geo, defgeo, bw, 1, 1, 0, 0,
                        &x, &y, &xwidth,&xheight);
        xsize=xwidth;
        ysize=xheight;

        /* default pixel values */
        mybackground = WhitePixel(mydisplay,myscreen);
        myforeground = BlackPixel(mydisplay,myscreen);

        /* default program-specified window position and size */
        myhint.x=x;
        myhint.y=y;
        myhint.flags = PPosition | USSize;
        myhint.width = xsize;
        myhint.height = ysize;

        gethostname(hostname,hostlen);
        strcpy(title,"FrameX ");
        if(strlen(hostname) !=0 )
        {
                strcpy(temp,"");
                sscanf(hostname,"%[^.]",temp);
                strcat(title,temp);
        }

        /* window creation */
        mywindow = XCreateSimpleWindow(mydisplay,
                DefaultRootWindow(mydisplay),
                myhint.x, myhint.y, myhint.width, myhint.height,
                5, myforeground, mybackground);

    /* needs to be updated to R4 WM call */
/*
        XSetStandardProperties(mydisplay, mywindow, title, title,
                None, argv, argc, &myhint);
*/
        titleptr=title;
        XStringListToTextProperty(&titleptr,1,&mytitle);

        /* default program-specified window position and size */
        myhint.x=x;
        myhint.y=y;
        myhint.flags = USPosition | USSize | PMaxSize | PMinSize ;
        myhint.width = xsize;
        myhint.height = ysize;
        myhint.min_width = xsize;
        myhint.min_height = ysize;
        myhint.max_width = xsize;
        myhint.max_height = ysize;

        XSetWMProperties(mydisplay,mywindow,&mytitle,&mytitle,argv,argc,
                &myhint,mywmhint,myclasshint);

        /* GC creation and initialization */
        mygc= XCreateGC(mydisplay, mywindow, 0, NULL);
        XSetBackground(mydisplay, mygc, mybackground);
        XSetForeground(mydisplay, mygc, myforeground);

        myfont = XLoadFont(mydisplay,"8x13");
        XSetFont(mydisplay,mygc,myfont);

        /* input event selection */
        XSelectInput(mydisplay,mywindow,
             ButtonPressMask | KeyPressMask | ExposureMask |
             PointerMotionMask);

        /* window mapping */
        XMapRaised(mydisplay, mywindow);

        /* line attributes */
        line_width=1;
        line_style=LineSolid;
        cap_style=CapButt;
        join_style=JoinMiter;
        XSetLineAttributes(mydisplay,mygc,line_width,line_style,cap_style,join_style);

        get_size();

        printf(" Depth = %i \n",depth);

        set_colors(); 
        def_olut_trace();     /* sets up the usr_lut */

        if((xsize != width)||(ysize != height))
        {
                printf("Wrong window size \n");
                exit(0);
        }

/*  reserve memory for the ximage data once depth is known -- must be global */

        if( depth <= 8)
        {
                size = (long)(width+2)*(height+2);
        }
         else
        {
                size = (long)(width+2)*(height+2)*3;/* for 24 bit need 3 bytes/pix */

        }

        imagedata = (unsigned char*) malloc((size_t) size);

        if(imagedata == NULL)
        {
                printf("unable to allocate ximage data memory \n");
                exit (0);
        }
        


/************************************************************

        for second window

**************************************************************/

        set_buttons(&w2xsize,&w2ysize);  /* set menu buttons */

         w2ysize = w2ysize + 2*fheight;

        /* default program-specified window position and size */
        my2hint.x=myhint.x;
        my2hint.y=myhint.y-w2ysize-30;
        my2hint.width=w2xsize;
        my2hint.height=w2ysize;
        my2hint.flags = PPosition | PSize;

        /* window creation */
        my2window = XCreateSimpleWindow(mydisplay,
                DefaultRootWindow(mydisplay),
                my2hint.x, my2hint.y, my2hint.width, my2hint.height,
                5, myforeground, mybackground);

        /* This uses R4 WM call */

        titleptr=title;
        XStringListToTextProperty(&titleptr,1,&my2title);

        /* default program-specified window position and size */

/*   should check where WM puts the first window to do this right */
        my2hint.x=myhint.x;
        my2hint.y=myhint.y-w2ysize-30;
        my2hint.flags = USPosition | USSize | PMaxSize | PMinSize ;
        my2hint.width = w2xsize;
        my2hint.height = w2ysize;

        my2hint.min_width = w2xsize;
        my2hint.min_height = w2ysize;
        my2hint.max_width = w2xsize;
        my2hint.max_height = w2ysize;

        XSetWMProperties(mydisplay,my2window,&my2title,&my2title,argv,argc,
                &my2hint,my2wmhint,my2classhint);

        /* GC creation and initialization */
        my2gc= XCreateGC(mydisplay, my2window, 0, 0);
        XSetBackground(mydisplay, my2gc, mybackground);
        XSetForeground(mydisplay, my2gc, myforeground);
        XSetFont(mydisplay,my2gc,myfont);

        /* input event selection */
        XSelectInput(mydisplay,my2window,
                ButtonPressMask | ExposureMask | PointerMotionMask
                | KeyPressMask | LeaveWindowMask );

        /* window mapping */
        XMapRaised(mydisplay, my2window);

/*   end of second window set up */

        /* Main event-reading loop */
        done = 0;
        while( done == 0) {
                /* read the next event */
            XNextEvent(mydisplay, &myevent);

            if(myevent.xany.window == mywindow)
            {
                switch(myevent.type){
                        /* repaint window on expose events */
                        case Expose:

                              if(myevent.xexpose.count == 0)
                              {
                                     if(auto_draw ==1) redraw();
                              }
                        break;

                        case MotionNotify:
                                if(show_pos == 1)
                                {
                                    col=myevent.xmotion.x;
                                    row=myevent.xmotion.y;
                                    printf("row = %3i col = %3i pixel = %3i \r",row,col,image(disbuf,row,col));
                                }

                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
                        	XRefreshKeyboardMapping(&myevent.xmapping);
                        break;

                        /* process mouse-button presses */
                        case ButtonPress:
                                    col=myevent.xbutton.x;
                                    row=myevent.xbutton.y;
                                    printf("row = %3i col = %3i pixel = %3i \n",row,col,image(disbuf,row,col));
                        break;

                        /* process keyboard input */
                        case KeyPress:
                                i = XLookupString( &myevent.xkey, text, 10, &mykey, 0);
                                if( i == 1 && text[0] == 'q') done = 1;
                                if( i == 1 && text[0] == 'm') menu();
                                if( i == 1 && text[0] == 's') quicksave();
                         break;
                } /* switch(myevent.type) */
             } /* if mywindow */

/**********************************************************

        second window events (menu choices )

**************************************************************/
          if(myevent.xany.window == my2window)
          {
                switch(myevent.type){
                        /* repaint window on expose events */
                        case Expose:
                        if(myevent.xexpose.count == 0) draw_buttons();
                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
         /* tws: fixed error in 1st arg &myevent --> &myevent.xmapping */
                        XRefreshKeyboardMapping(&myevent.xmapping);
                        break;

                        case LeaveNotify:
                                             draw_buttons();
                                             q = -1;
                        break;

                        case MotionNotify:
                                if(q != -1)
                                {
                                        if(q != which_button(myevent.xmotion.x,myevent.xmotion.y) )
                                        {
                                             draw_buttons();
                                             q = -1;
                                        }
                                  }
                        break;

                        /* process mouse-button presses */
                        case ButtonPress:

                                 q=check_button(myevent.xbutton.x,
                                              myevent.xbutton.y);

                                 if(q==0)  /* first menu choice  */
                                 {
                                        menu();
                                 }
                                 if(q==1)
                                 {
                                        if(grab_on == 0 && scan == 0) auto_trace();
#ifdef SVIDEO
                                        if(grab_on == 1)
                                        {
                                                grab_sv();
                                                if(newimage == 1) redraw();
                                        }
#endif

#ifdef LOGISCAN
					if(scan == 1)
					{
						do_scan();
					}
#endif					
                                 }
                                 if(q==2)
                                 {
                                       smooth();
                                 }

                                 if(q==3) edit();

                                 if(q==4) /* toggle buffers */
                                  {
                                        disbuf = 1 - disbuf;
                                        set_buffer();
                                        newimage = 1;
                                        redraw();
                                  }

                                  if(q==menu1.num_buttons-1) done = 1;  /* quit */

                        break;

                        /* process keyboard input (same as main window) */
                        case KeyPress:
                                i = XLookupString( &myevent.xkey, text, 10, &mykey, 0);
                                if( i == 1 && text[0] == 'q') done = 1;
                                if( i == 1 && text[0] == 'm') menu();
                                    if( i == 1 && text[0] == 's') quicksave();
                         break;


                } /* switch(myevent.type) */
         } /* end of second window if */


        } /* while(done == 0) */

        printf("\n");

        frame_exit();
}

#ifdef SVIDEO

grab_sv()
{
/*

        grabs an image with the starter video board on an SGI indigo

        converts the image to b/w

        must have 640x480 image size

        use -g switch to set up for grab: image size and menus

*/
    short val;
    long livewin, stillwin, x, y;
    SVhandle V;
    long param[2];
    int videoon = 1;
    short rbuf[SV_PAL_XMAX];
    short gbuf[SV_PAL_XMAX];
    short bbuf[SV_PAL_XMAX];
    short obuf[SV_PAL_XMAX];
    unsigned char *rgbbuf;
    unsigned char *data;


        if((width != SV_NTSC_XMAX) && (height != SV_NTSC_YMAX))
        {
                printf("**** Cannot grab frame -- wrong window size ****\n");
                return(0);
        }

         /* Open video device */

        if ((V = svOpenVideo()) == NULL) {
                svPerror("open");
                return(0);
        }


        printf("rgbbuf malloc, size = %i \n",SV_PAL_XMAX*SV_PAL_YMAX*sizeof(long));
        rgbbuf = (unsigned char*) malloc((size_t)SV_PAL_XMAX*SV_PAL_YMAX*sizeof(long));

        if(rgbbuf == NULL)
        {
                printf("cannot allocate rgb buffer \n");
                return(0);
        }


        if( svCaptureOneFrame(V, SV_RGB32_FRAMES, &width, &height, rgbbuf) != 0)        {
           svPerror("CaptureOneFrame");
           return(0);
        }

        data = rgbbuf;

        for (y=0;y<height;y++)
        {
                for(x=0;x<width;x++)
                {
                        bbuf[x] = *(data+1);
                        gbuf[x] = *(data+2);
                        rbuf[x] = *(data+3);
                        data += 4;
                }

        /* convert to bw with rgbrowtobw  */

                rgbrowtobw(rbuf,gbuf,bbuf,obuf,width);


                for(x=0;x<width;x++)
                {
                        putimage(disbuf,height-y-1,x,obuf[x]);
                }


        }

        free(rgbbuf);

        newimage = 1;

        printf("Frame grabbed to buffer %i \n",disbuf);

}

#endif

unsigned char image(int buffer,int row, int col)
{
/*
        get data out of imagebuff this is a replacement for

        image[buf][row][col]

*/
        return(*(imagebuff+col+width*row+buffer*height*width));
}

putimage(int buffer,int row, int col,int pix)
{
        *(imagebuff+col+width*row+buffer*height*width)=(unsigned char)pix;
}

blank(int pix)
{            /* zero out the buffers */
int i,j;
unsigned char *iprt;

        for(i=0;i<width;i++)
        {
                for(j=0;j<height;j++)
                {
                        iprt=imagebuff+i+j*width;
                        *iprt = (unsigned char) pix;
                }
        }
}



set_buffer()
{
/*
        sets the menu caption for toggle buffers based on
        the value of disbuf

*/
         if(disbuf==0)
         {
              strcpy(buttons[4].text,"Buffer 1");
         }
         else
         {
              strcpy(buttons[4].text,"Buffer 0");
         }
}


set_colors()
{
int status,i,j,k,k1;
unsigned long pixel;
char colorname[20];
char temp[50];


            strcpy(temp,"Getting Colors");

            XDrawImageString( mydisplay,mywindow, mygc,width/2-10,height/2,
                                temp, strlen(temp));

            XFlush(mydisplay);

         set_bw();

         if(depth == 1) return(0);


        mycolormap = DefaultColormap(mydisplay,myscreen);

/* get a color for overlaying data */

        strcpy(colorname,color_pix_name); /* set in the global defs */
        XAllocNamedColor(mydisplay,mycolormap,colorname,&mycolor_def,&mycolor_rgb);
        color_pix = mycolor_def.pixel;

        if(depth == 4)
        {


             strcpy(colorname,"grey50");

             status=XAllocNamedColor(mydisplay,mycolormap,colorname,&mycolor_def,&mycolor_rgb);

/*
             printf(" white = %i \n",mybackground);
             printf(" black = %i \n",myforeground);
             printf(" grey50 = %i \n",mycolor_def.pixel);
*/
             if(status != 0 )
             {
                     pixel = mycolor_def.pixel;

                      for(i=50;i<150;i++)
                      {
                             lut[i]=pixel;

                      }

              }
              else
              {
                     printf(" failed on %s \n",colorname);
                     set_bw();
                     return(0);
              }


         }


        if(depth >= 8) /* works for any depth greater than 8 */
        {

        k1=3;
        i=0;

        for(k=0;k<101;k++)
        {

              sprintf(colorname,"grey%i",k);

              status=XAllocNamedColor(mydisplay,mycolormap,colorname,&mycolor_def,&mycolor_rgb);
/*
              printf(" %s = %i \n",colorname,mycolor_def.pixel);
*/
              if(status != 0 )
              {
                      pixel = mycolor_def.pixel;

                      for(j=0;j<k1;j++)
                      {

                            lut[i]=pixel;
                            i++;
                      }
/*
        alternate 3 and then 2 pixel levels per grey color
        see rgb.txt
*/
                      k1=5-k1;

              }
              else
              {
                     printf(" failed on %s \n",colorname);
                     set_bw();
                     return(0);
              }

         }

         }
}

set_bw()
{
int i;

        for(i=0;i<256;i++)
        {

                        if(i < 128)
                        {
                                lut[i]= myforeground;
                        }
                        else
                        {
                                lut[i]=mybackground;
                        }
         }

         color_pix = myforeground;

}



redraw()
{
/*
        writes image directly to data structure and then uses
        _XInitImageFuncPtrs (an internal Xlib function)
        to convert to server format

        This is the fast method ...


*/
int i,j;
char temp[50];
char *data;

  if(newimage == 1)
  {

        strcpy(temp,"Getting Image ");

        XDrawImageString( mydisplay,mywindow, mygc,width/2-10,height/2,
                                temp, strlen(temp));

        XFlush(mydisplay);

        data=(char*)imagedata;

         if(myimage == NULL )  /* drop thru if ximage already has been created */
         {
              myimage=XCreateImage(mydisplay,DefaultVisual(mydisplay,myscreen),
                             depth,ZPixmap,0,data,xsize,ysize,8,0);
         }

/* diagnostics ...

        printf(" byte_order = %i \n",myimage->byte_order);
        printf(" bitmap_unit = %i \n",myimage->bitmap_unit);
        printf(" bitmap_pad = %i \n",myimage->bitmap_pad);
        printf(" depth = %i \n",myimage->depth);
        printf(" bytes_per_line = %i \n",myimage->bytes_per_line);
        printf(" xoffset = %i \n",myimage->xoffset);
        printf(" bits_per_pixel = %i \n",myimage->bits_per_pixel);
*/

        strcpy(temp,"Filling Image ");

        XDrawImageString( mydisplay,mywindow, mygc,width/2-10,height/2,
                                temp, strlen(temp));

        XFlush(mydisplay);


  /* set these for my data, not the servers */

        myimage->byte_order = 1;
        myimage->bitmap_bit_order = 1;
        myimage->bitmap_unit = 8;

/* all are 0 ---> color cell values (not direct color) */

        myimage->red_mask = 0;
        myimage->green_mask = 0;
        myimage->blue_mask = 0;

        if(depth == 4)
        {
                myimage->bits_per_pixel = 4;
                myimage->bytes_per_line = width/2;

/*
        this assumes imagedata[480][512]

        must fill all of each row out to 512
        because X assumes that data is contigious in memory

        Don't have this problem any more

        cannot handle odd widths

*/

/*  old version
                for(i=0;i<240;i++)
                {
                        for(j=0;j<256;j++)
                        {
                        imagedata[i][j]=lut[usr_lut[image(disbuf,2*i,2*j)]]*16
                                       +lut[usr_lut[image(disbuf,2*i,2*j+1)]];
                        }

                        for(j=0;j<256;j++)
                        {
                        imagedata[i][j+256]=lut[usr_lut[image(disbuf,2*i+1,2*j)]]*16
                                           +lut[usr_lut[image(disbuf,2*i+1,2*j+1)]];
                        }
                }

*/

                for(i=0;i<height;i++)
                {
                        for(j=0;j<width/2;j++)
                        {

                    *(imagedata+i*width/2+j)=lut[usr_lut[image(disbuf,2*i,2*j)]]*16
                                       +lut[usr_lut[image(disbuf,2*i,2*j+1)]];
                        }

                 }


        }

        if(depth == 8)
        {
               myimage->bits_per_pixel = 8;
               myimage->bytes_per_line = width;
/* done below
               for(i=0;i<480;i++)
               {
                       for(j=0;j<width;j++)
                       {
                               imagedata[i][j]=lut[usr_lut[image(disbuf,i,j)]];
                       }
               }

*/
               for(i=0;i<height;i++)
               {
                       for(j=0;j<width;j++)
                       {
                               *(imagedata+i*width+j)=lut[usr_lut[image(disbuf,i,j)]];
                       }
               }

        }

        if(depth == 24)  /* assume true color, skip using lut[] */
        {
               myimage->bits_per_pixel = 24;
               myimage->bytes_per_line = width*3;

               for(i=0;i<height;i++)
               {
                       for(j=0;j<width;j++)
                       {
                               *(imagedata+i*width*3+j*3)=usr_lut[image(disbuf,i,j)];
                               *(imagedata+i*width*3+j*3+1)=usr_lut[image(disbuf,i,j)];
                               *(imagedata+i*width*3+j*3+2)=usr_lut[image(disbuf,i,j)];

                       }
               }

        }


/*
        myimage->width=xsize;
        myimage->height=ysize;
        myimage->xoffset = 0;
        myimage->format=ZPixmap;
        myimage->data = imagedata;
        myimage->byte_order = 1;
        myimage->bitmap_unit = 8;
        myimage->bitmap_bit_order = LSBFirst;
        myimage->bitmap_pad=8;
        myimage->depth=depth;
        myimage->bytes_per_line = width;
*/

        strcpy(temp,"Converting Image ");

        XDrawImageString( mydisplay,mywindow, mygc,width/2-10,height/2,
                                temp, strlen(temp));

        XFlush(mydisplay);

        _XInitImageFuncPtrs(myimage);

        strcpy(temp,"Putting Image    ");

        XDrawImageString(mydisplay,mywindow, mygc,width/2-10,height/2,
                                temp, strlen(temp));

        XFlush(mydisplay);

        XPutImage(mydisplay,mywindow,mygc,myimage,0,0,0,0,xsize,ysize);

        newimage = 0;

     }
     else
     {

           XPutImage(mydisplay,mywindow,mygc,myimage,0,0,0,0,xsize,ysize);

     }
}

get_size()
{
int x,y;

        XGetGeometry(mydisplay,mywindow,&root,
                     &x,&y,&xsize,&ysize,&border_width,&depth);
}

int menu()
{
        char q[20];
        int q1;

        show_menu();
again:
        printf("\n");
        strcpy(q, "99");
        get_default_s("Input function",q);

        if(strcmp(q, "99") == 0 )
        {
                return(0);
        }

        q1 = 0;

        if(strlen(q) == 1)  /* allow letter short cuts */
        {

                if(q[0]=='s') q1 = 5;
                if(q[0]=='w') q1 = 5;
                if(q[0]=='r') q1 = 6;
                if(q[0]=='m') q1 = 13;
                if(q[0]=='q') q1 = -1;
        }

        if(q1 == 0 ) q1 = atoi(q);

        switch(q1)
        {
                case 0:
                        show_menu();
                        goto again;

                case -1:
                        frame_exit();
                        break;
                case 1:
                        auto_draw=1-auto_draw;
                        break;
                case 2:
                        edit();
                        break;
                case 3:
                        disbuf = 1 - disbuf;
                        set_buffer();
                        printf("Current display buffer is %i \n",disbuf);
                        newimage = 1;
                        redraw();
                        break;
                case 4:
                        def_olut();
                        newimage=1;
                        redraw();
                        break;
                case 5:
                        write_frame();
                        break;
                case 6:
                        read_both();
                        if(newimage == 1) redraw();
                        break;
                case 7:
                        auto_trace();
                        break;
                case 8:
                        save();
                        break;
                case 9:
                        set_pars();
                        if(newimage == 1) redraw();
                        break;
                case 10:
                        draw_limits();
                        cross_hair();
                        set_limits();
                        default_cursor();
                        draw_limits();
                        break;
                case 11:
                        delete();
                        break;
                case 12:
                        smooth();
                        break;
                case 13:
                        math_frame();
                        break;
                case 14:
                        fill_box();
                        break;
                case 15:
                        histogram();
                        histogram2();
                        break;
                case 16:
                        offset_frame();
                        break;
                case 17:
                        level_frame();
                        break;
#ifdef SVIDEO
                case 18:
                        grab_sv();
                        if(newimage == 1) redraw();
                        break;
#endif
#ifdef LOGISCAN
		case 18:
			do_scan();
			newimage = 1;
			redraw();
			break;
#endif			
                default:
                       break;
        }

}

int show_menu()
{
        printf("\nFunctions are:\n");
        printf("\t1\tToggle auto redraw window \n");
        printf("\t2\tEdit pixels\n");
        printf("\t3\tToggle display buffer \n");
        printf("\t4\tDefine output LUT \n");
        printf("Storage");
        printf("\t5\tWrite current display buffer to file\n");
        printf("\t6\tRead into current display buffer from file\n");
        printf("Tracing");
        printf("\t7\tTrace fringes \n");
        printf("\t8\tSave current trace data to file \n");
        printf("\t9\tSet tracing parameters \n");
        printf("\t10\tDisplay/set limits\n");
        printf("\t11\tDelete last fringe traced\n");
        printf("Data");
        printf("\t12\tSmoothing \n");
        printf("\t13\tMath      \n");
        printf("\t14\tFill Box \n");
        printf("\t15\tHistogram\n");
        printf("\t16\tOffset\n");
        printf("\t17\tLevel filter\n");
#ifdef SVIDEO
        printf("Input");
        printf("\t18\tGrab frame \n");
#endif
#ifdef LOGISCAN
        printf("Input");
        printf("\t18\tScan image \n");
#endif
        printf("\n\t0\tPrint menu\n");
        printf("\t99\tExit menu\n");
        printf("\t-1\tExit program\n");
}

int read_both()
{
/*      Corrected for bit order problem in .cmp files on 5/22/90

        reads .img or .cmp files into the image array

         now reads sgi RGB files too

        Requires an extension to be included to determine the file type.

        Modified with compiler if for sun/sgi on 2/15/93

        use -DMSDOS for compile in msdos (byte order problem)

        checks cmdline to see if file[] already set
        
        reads PBM type P4 and P5 files

*/

        unsigned short vid_rowc[100];  /* two bytes long */
        int i,b1[16],j,k,l,file_type,fchk,bits;
        char *iptr,c1,c2,temp[50];
        long isize;

#ifdef SGIIMAGE
        IMAGE *sgiimage;
         int sgi_xsize,sgi_ysize,sgi_nchan;
        short rbuf[800],gbuf[800],bbuf[800],obuf[800];
#endif

        printf("Current buffer is %i \n",disbuf);

again:  if(cmdline == 0)
        {

#ifdef SGIIMAGE
           printf("Read frame file name (q = quit) (.img .cmp .pbm .sgi) = ");
#else
           printf("Read frame file name (q = quit) (.img .cmp .pbm) = ");
#endif
           gets(file);
           if((file[0]=='q' || file[0]=='Q') && strlen(file)==1 )
           {
                return(-1);
           }

        }
        else  cmdline = 0;


        if( strchr(file,'.') == NULL)
        {
             printf("*** Filename must include extension ***\n");
             goto again;
        }
        else
        {
             file_type = 0;
             if( strstr(file,".img") != NULL ) file_type = 1;
             if( strstr(file,".cmp") != NULL ) file_type = 2;
             if( strstr(file,".IMG") != NULL ) file_type = 1;
             if( strstr(file,".CMP") != NULL ) file_type = 2;
#ifdef SGIIMAGE
             if( strstr(file,".sgi") != NULL ) file_type = 3;
             if( strstr(file,".SGI") != NULL ) file_type = 3;
#endif
             if( strstr(file,".pbm") != NULL ) file_type = 4;
             if( strstr(file,".PBM") != NULL ) file_type = 4;

             if(file_type == 0)
             {
                printf("*** Invalid extension ***\n");
                goto again;
             }
        }

        if(file_type == 2)
        {
                if( 16*(width/16) != width )
                {
                        printf(" Cannot uncompress: width not multiple of 16 \n");
                        goto again;
                }
        }


        fileprt = fopen(file,"rb");

        if(fileprt == NULL )
        {
                printf("*** File not found ***\n");
                goto again;
        }

        if(file_type == 1)
        {
             for(i=0;i<height;i++)
             {
                 iptr = (char *)(imagebuff+i*width+disbuf*width*height);

                 fchk=fread(iptr,1,width,fileprt);
                 if(fchk != width)
                 {
                        printf("*** error on read *** \n");
                        fclose(fileprt);
                        newimage=1;
                        return(-1);
                 }
             }
        }

        if(file_type == 2)
        {
             for(i=0;i<height;i++)
             {
/*
     if we switch vid_row to unsigned char and read in 64 at a time
     we don't have a machine specific problem, but
     current format has alternate bytes reversed.

*/
                 fchk=fread(&vid_rowc[1],sizeof(vid_rowc[1]),width/16,fileprt);
                 if(fchk != width/16)
                 {
                        printf("*** error on read *** \n");
                        fclose(fileprt);
                        newimage=1;
                        return(-1);
                 }


                 for(j=1;j<width/16+1;j++)
                 {
                        to_bits(b1,(int)vid_rowc[j]);

                        for(l=0;l<16;l++)
                        {
#ifdef INTEL
                              k=16*(j-1)+l;
#else
/*   we need to alternate bytes read in on sun's and sgi's */
                              if(l < 8)
                                    k=16*(j-1)+l+8; /* first byte  */
                              else
                                    k=16*(j-1)+l-8;   /* 2nd byte */
#endif

                              putimage(disbuf,i,k,b1[15-l]*255);
                        }
                 }
             }
        }

#ifdef SGIIMAGE

        if(file_type == 3)
        {
                fclose(fileprt);
                sgiimage = iopen(file,"r");

                if(sgiimage == NULL){
                        printf("Cannot open image as SGI file \n");
                        return(0);
                }

                sgi_xsize = sgiimage->xsize;
                sgi_ysize = sgiimage->ysize;
                sgi_nchan = sgiimage->zsize;

                if( newimage == 2)
                {
                        width = sgi_xsize;
                        height = sgi_ysize;
                        printf("setting size to %i x %i \n",width,height);
                        isize = 2*height*width;
                        imagebuff = realloc(imagebuff,(size_t) isize);
                }

                if((width != sgi_xsize) && (height != sgi_ysize))
                {
                        printf("SGI image size does not match: %i x %i \n",sgi_xsize,sgi_ysize);
                        iclose(sgiimage);
                        return(0);
                }


                printf("Number of channels is %i \n",sgi_nchan);

                for(i=0; i<sgi_ysize; i++) {
                        if(sgi_nchan < 3) {
                            getrow(sgiimage,obuf,i,0);
                        } else {
                            getrow(sgiimage,rbuf,i,0);
                            getrow(sgiimage,gbuf,i,1);
                            getrow(sgiimage,bbuf,i,2);
                            rgbrowtobw(rbuf,gbuf,bbuf,obuf,sgi_xsize);
                        }
                        for(j=0;j<sgi_xsize;j++)
                        {
                                putimage(disbuf,sgi_ysize-i-1,j,obuf[j]);
                        }

                }
                iclose(sgiimage);
                newimage = 1;
                strcpy(contents[disbuf],file);
                return(0);
        }

#endif
/*
	PBM file type P4 or P5

*/
        if(file_type == 4)
        {
             c1=fgetc(fileprt);
             c2=fgetc(fileprt);
             if( c1 != 'P'|| !(c2 == '4' || c2 == '5') )
             {
             	printf(" **** error not PBM (P4/5) file *****");
             	fclose(fileprt);
             	return(-1);
             }
             c1=fgetc(fileprt); /* get the \n */
morepbm:
             fgets(temp,50,fileprt);
             if(temp[0] == '#' ) goto morepbm; /* comments */
             
             sscanf(temp,"%i %i",&width,&height);
             printf("setting size to %i x %i \n",width,height);
             
             isize = 2*height*width;
             imagebuff = realloc(imagebuff,(size_t) isize);
             
             if(c2 == '5') /* color version */
             {
             	fgets(temp,50,fileprt);
             	sscanf(temp,"%i",&bits);
             	if(bits != 255)
             	{
             		printf("**** not grayscale PBM *****");
             		fclose(fileprt);
             		return(-1);
             	}
             }

             for(i=0;i<height;i++)
             {
                 iptr = (char *)(imagebuff+i*width+disbuf*width*height);

                 fchk=fread(iptr,1,width,fileprt);
                 if(fchk != width)
                 {
                        printf("*** error on read *** \n");
                        fclose(fileprt);
                        newimage=1;
                        return(-1);
                 }
             }
        }

error:
        fclose(fileprt);
        newimage = 1;
        strcpy(contents[disbuf],file);
        return(0);
}

int to_bits( int bits[], int value)
{
/*
        Decomposes the value (16 bits) into its binary bits.
        Returns them in bits[k], k=0 to 15.
*/
#define max_pwr 32768L
        unsigned index;
        int outcome,bin_place;

        bin_place = 15;
/* was index > 0 but index is unsigned ! */
        for (index= max_pwr; index != 0 ; index /= 2)
        {
                outcome = (int) (value / index);
                if( (outcome == 1) || (outcome == -1))
                        bits[bin_place--] = 1;
                else
                        bits[bin_place--] = 0;

                value %= index;
        }
}


int write_frame()
{
/*
        Write file from the image array to disk
        file is written as either .img or .cmp file depending
        on extension given.  If .cmp is used the program prompts for
        the bin_level.

         also writes SGI RBG format files (w/ -DSGI )

*/
        int file_type,fchk;
        unsigned short vid_rowc[100],s1,b1,b2,s2;
        int i,j,k,l,bin,k1,l1,l2;
        char *iptr;

#ifdef SGIIMAGE
        IMAGE *sgiimage;
        short rbuf[1200],bbuf[1200],gbuf[1200];  /* should really be malloc'ed */
        short rlut[256],blut[256],glut[256],pix;
        int uselut;
#endif

#ifndef INTEL
        double d1,d2,d;
#endif
        unsigned short p1[8],p2[8];
        char q[10];

        bin = 128;

        printf("Current buffer is %i \n",disbuf);

#ifdef SGIIMAGE
again:  printf("Output frame file name (q = quit) (.img, .cmp or .sgi) = ");
#else
again:  printf("Output frame file name (q = quit) (.img or .cmp) = ");
#endif
        gets(file);

        if((file[0]=='q' || file[0]=='Q') && strlen(file) == 1)
        {
             return(0);
        }
        if( strchr(file,'.') == NULL)
        {
             printf("*** Filename must include extension ***\n");
             goto again;
        }
        else
        {
             file_type = 0;
             if( strstr(file,".img") != NULL ) file_type = 1;
             if( strstr(file,".cmp") != NULL ) file_type = 2;
             if( strstr(file,".IMG") != NULL ) file_type = 1;
             if( strstr(file,".CMP") != NULL ) file_type = 2;
#ifdef SGIIMAGE
             if( strstr(file,".sgi") != NULL ) file_type = 3;
             if( strstr(file,".SGI") != NULL ) file_type = 3;
#endif

             if(file_type == 0)
             {
                printf("*** Invalid extension ***\n");
                goto again;
             }
        }

        if(file_type == 2)
        {
                if( 16*(width/16) != width )
                {
                        printf(" Cannot compress: width not multiple of 16 \n");
                        goto again;
                }
        }

        if((fileprt=fopen(file,"r")) != NULL )
        {
               fclose(fileprt);
               strcpy(q,"n");
               get_default_s(" File exists, Overwrite (y/n) ",q);
               if( q[0] != 'y' && q[0] != 'Y')
               {
                     goto again;
               }
        }


        fileprt = fopen(file,"wb");

        if(fileprt == NULL )
        {
                printf("Cannot open file \n");
                goto again;
        }

        if(file_type == 1 )
        {

             for(i=0;i<height;i++)
             {
                iptr = (char *)(imagebuff+i*width+disbuf*width*height);

                 fchk=fwrite(iptr,1,width,fileprt);
                 if(fchk != width)
                 {
                        printf("***** Write Error *****\n");
                        fclose(fileprt);
                        remove(file);
                        printf("***** File not written *****\n");
                        return(-1);
                 }
             }
             fclose(fileprt);
             printf("\nBuffer Saved as .img file\n\n");
        }

        if(file_type == 2)
        {

again4:          get_default_i("Enter Binerization level (0-255)",&bin);
                 if( (bin < 0 )||( bin > 255 ) )
                 {
                     printf("**** Invalid level *****\n");
                     goto again4;
                 }

             printf("Working ...\n");

             for(l=0;l<8;l++)
             {
                   l1=15-2*l;
                   l2=14-2*l;
#ifdef INTEL
                   p1[l]=(unsigned short)pow(2,l1);
                   p2[l]=(unsigned short)pow(2,l2);
#else
                   d=2.;
                   d1=(double)l1;
                   d2=(double)l2;
                   p1[l]=(unsigned short)pow(d,d1);
                   p2[l]=(unsigned short)pow(d,d2);
#endif
             }

             for(i=0;i<height;i++)
             {
                 for(j=1;j<width/16+1;j++)
                 {
                        k=8*(j-1)+1;
                        s1=0;
                        s2=0;
                        for(l=0;l<8;l++)
                        {
                              k1=k+l;
                              b1=(unsigned short)image(disbuf,i,2*k1-2);
                              b2=(unsigned short)image(disbuf,i,2*k1-1);
                              if( b1 >= bin )
                              {
                                     b1 = 1;
                              }
                              else
                              {
                                     b1 = 0;
                              }
                              if( b2 >= bin )
                              {
                                     b2 = 1;
                              }
                              else
                              {
                                     b2 = 0;
                              }
                              s1=s1+b1*p1[l]+b2*p2[l];

                        }
#ifdef INTEL
                        vid_rowc[j]=s1;
#else
                /* swap the bytes for sun or sgi */
                        s2=s1/256;
                        s1=s1%256;
                        vid_rowc[j]=s1*256+s2;
#endif

                 }

                 fchk=fwrite(&vid_rowc[1],sizeof(vid_rowc[1]),width/16,fileprt);
                 if(fchk != width/16 )
                 {
                        printf("***** Write Error *****\n");
                        fclose(fileprt);
                        remove(file);
                        printf("***** File not written *****\n");
                        return(-1);
                 }

             }
             fclose(fileprt);
             printf("\nBuffer Saved as .cmp file\n\n");
        }

#ifdef SGIIMAGE

        if(file_type == 3)
        {

                k = 1;
                get_default_i("Number of channels in SGI file (1,3) ",&k);
                if( k != 1 && k != 3) k = 1;

                fclose(fileprt);

            if(k == 1)
            {

                sgiimage = iopen(file,"w",RLE(1),3,width,height,1);
                for(i=0; i<height; i++) {
        /*
                fill obuf with pixel values -- 1 channel only
        */
                for(j=0;j<width;j++)
                        {
                                rbuf[j]=image(disbuf,height-i-1,j);
                        }

                putrow(sgiimage,rbuf,i,0);   /* grey scale image */
                }


            }
            else
            {

                uselut=1;
                get_default_i("Color map 1=gray 2=rgb 3=100 grays ",&uselut);

                if(uselut == 1)
                {
                        for(i=0;i<256;i++)
                        {
                                rlut[i]=i;
                                glut[i]=i;
                                blut[i]=i;
                        }
                }

                if(uselut == 2)
                {
                        for(i=0;i<256;i++)
                        {
/* old diagonal map
                                if(i <= 127 )
                                {
                                        rlut[255-i]=0;
                                        glut[255-i]=2*i;
                                        blut[255-i]=255-i*2;
                                }
                                else
                                {
                                        rlut[255-i]=(i-128)*2;
                                        glut[255-i]=255-(i-128)*2;
                                        blut[255-i]=0;
                                }
*/

                         if( i <= 63 )
                                {
                                 rlut[i] = 0;
                                 glut[i] = i * 4;
                                 blut[i] = 255;
                                }

                                if( i > 63 && i <= 127 )
                                {
                                          rlut[i] = 0;
                                  glut[i] = 255;
                                  blut[i] = 255 - (i - 64) * 4;
                                }

                                if( i > 127 && i <= 191 )
                                {
                                        rlut[i] = (i - 128) * 4;
                                        glut[i] = 255;
                                        blut[i] = 0;
                                }

                                if( i > 191 && i <= 255 )
                                {
                                        rlut[i] = 255 ;
                                        glut[i] = 255 - (i - 192) * 4;
                                        blut[i] = 0;
                                }


                        }

/* make pure white map to pure white for null color */

                        rlut[255]=255;
                        glut[255]=255;
                        blut[255]=255;


                }

                if(uselut == 3)
                {

                        k1 = 3;
                        i=0;
                        pix = 0;

                        for(k=0;k<102;k++)
                        {

                            for(j=0;j<k1;j++)
                           {

                                rlut[i]=pix;
                                glut[i]=pix;
                                blut[i]=pix;
                               i++;
                           }

                           pix = pix + k1;
/*
        alternate 3 and then 2 pixel levels per grey color
        see rgb.txt
*/
                           k1=5-k1;

                        }
                         rlut[255] = 255;
                         blut[255] = 255;
                         glut[255] = 255;

                }

                sgiimage = iopen(file,"w",RLE(1),3,width,height,3);

                for(i=0; i<height; i++)
                {
        /*
                fill obuf  with pixel values and use for all channels
        */
                        for(j=0;j<width;j++)
                        {
                                rbuf[j]=rlut[image(disbuf,height-i-1,j)];
                                gbuf[j]=glut[image(disbuf,height-i-1,j)];
                                bbuf[j]=blut[image(disbuf,height-i-1,j)];
                        }

                        putrow(sgiimage,rbuf,i,0);              /* RGB image */
                        putrow(sgiimage,gbuf,i,1);              /* RGB image */
                        putrow(sgiimage,bbuf,i,2);              /* RGB image */
                }


           }
           iclose(sgiimage);
           printf("\n buffer saved as .sgi file \n\n");
        }

#endif

        strcpy(contents[disbuf],file);

}

int quicksave()
{
int i,fchk;
char *iptr;

        fileprt = fopen("fxtemp.img","wb");

        if(fileprt == NULL )
        {
                printf("Cannot open file fxtemp.img \n");
                return(-1);
        }


             for(i=0;i<height;i++)
             {
                iptr = (char *)(imagebuff+i*width+disbuf*width*height);

                 fchk=fwrite(iptr,1,width,fileprt);
                 if(fchk != width)
                 {
                        printf("***** Write Error *****\n");
                        fclose(fileprt);
                        remove(file);
                        printf("***** File not written *****\n");
                        return(-1);
                 }
             }
             fclose(fileprt);
             printf("\nBuffer Saved in fxtemp.img \n\n");
}


int histogram()
{
        int row,i,i1,i2;
        float bin[11];
        float total;
        printf("Working ... \n");
        total = 0.;

        for (i=0;i<11;i++) bin[i]=0.;

        for(row=0;row<height;row++)
        {

            for (i=0;i<width;i++)
            {
                   i1=(int)(image(disbuf,row,i));

                   total = total+i1;

                   bin[(int)floor(i1/25)]+=1;
            }
        }

        for(i=0;i<11;i++)
        {
        i1=i*25;
        i2=(i+1)*25-1;
        if(i2 > 255 ) i2=255;
        printf("%3i to %3i = %f\n",i1,i2,bin[i]);
        }
        i = (int)(total/((float)(width*height)));
        printf("Average level = %i\n",i);
}

int histogram2()
{
/*
     gives results as a line plot over the image

*/
        int row,i,i1;
        float bin[255];
        float maxbin;
        float total;
        int x1,x2,y1,y2;

/*        printf("Working ... \n");   */
        total = 0.;

        for (i=0;i<256;i++) bin[i]=0.;

        for(row=0;row<height;row++)
        {

            for (i=0;i<width;i++)
            {
                   i1=(int)(image(disbuf,row,i));

                   total = total+i1;

                   bin[i1]+=1;
            }
        }

        maxbin=0.;
        for(i=0;i<256;i++)
        {
                if(bin[i] > maxbin) maxbin = bin[i];
        }

        i = (int)(total/((float)(width*height)));

/*         printf("Average level = %i\n",i);  */

        XSetForeground(mydisplay,mygc,color_pix);

        for(i=1;i<256;i++)
        {
            x1 =(int)( (float)width*(float)(i-1)/255.);
            x2 =(int)( (float)width*(float)(i)/255.);
            y1=height/2-(int)(height*bin[i-1]/maxbin/2.);
            y2=height/2-(int)(height*bin[i]/maxbin/2.);

            double_line(x1,y1,x2,y2);
         }

/* draw baseline */

         x1=0;
         x2=width -1;
         y1=height/2;
         y2=height/2;
         double_line(x1,y1,x2,y2);

         XSetForeground(mydisplay,mygc,myforeground);

}

frame_exit()
{
        /* make sure we save traced curves */
        if(old_pts != 0) save();

        if(imagebuff != NULL ) free(imagebuff);
        if(myimage != NULL ) XDestroyImage(myimage);

/* XdestroyImage does this already !!
        if(imagedata != NULL ) free(imagedata);
*/

#ifdef LOGISCAN
	if(scan_buf != NULL) free(scan_buf);
#endif

        /* termination */
        if(mydisplay != NULL)
        {
                XFreeGC(mydisplay, mygc);
                XDestroyWindow(mydisplay, mywindow);

/* for window 2 */

                XFreeGC(mydisplay, my2gc);
                XDestroyWindow(mydisplay, my2window);

                XCloseDisplay(mydisplay);
        }
        exit(0);
}

usage(cmd)
     char       *cmd;
{

#ifdef SVIDEO
  fprintf(stderr, "usage: %s [-d display] [-h height] [-w width] [-n level] [-g] [filename]\n", cmd);
#else
  #ifdef LOGISCAN
    fprintf(stderr, "usage: %s [-d display] [-h height] [-w width] [-n level] [-s inches] [filename]\n", cmd);
  #else
    fprintf(stderr, "usage: %s [-d display] [-h height] [-w width] [-n level] [filename]\n", cmd);
  #endif
#endif


}


/***************************************************************

        menu window routines for buttons  (newwork)

***************************************************************/


draw_buttons()
{
int i,x,y,l;
char txt[50];

/*
             draws all the buttons

             assumes menu1 and window my2window

             and buttons[i] structure

             puts buffer contents display

             and puts question if it is not null
*/

        XClearWindow(mydisplay,my2window);

        for(i=0;i<menu1.num_buttons;i++)
        {
                l=strlen(buttons[i].text);
                x=buttons[i].x-(fwidth*l)/2;

                XDrawImageString( mydisplay,
                        my2window, my2gc,x, buttons[i].y,
                        buttons[i].text, l);

                x=buttons[i].x-((int)menu1.width)/2;
                y=buttons[i].y-((int)menu1.height)/2;

                XDrawRectangle(mydisplay,my2window,my2gc,
                        x,y,menu1.width,menu1.height);
         }


/* put question if set */

        if(strlen(question) > 0)
        {
                l=strlen(question);
/*
                x=buttons[menu1.num_buttons+1].x-(fwidth*l)/2;

                XDrawImageString( mydisplay,
                        my2window, my2gc,x, buttons[0].y,
                        question, l);
*/

        	x = 3;
        	y = my2hint.height-fheight;

                XDrawImageString( mydisplay,
                        my2window, my2gc,x, y,
                        question, l);

        }
	 else
	 {

/* put buffer contents on the last line */


        	x = 3;
        	y = my2hint.height-fheight;
        	strcpy(txt,"Buffer 0: ");
        	strcat(txt,contents[0]);
        	l = strlen(txt);

                XDrawImageString( mydisplay,
                        my2window, my2gc,x, y,
                        txt, l);

        	x = my2hint.width/2+2;
        	y = my2hint.height-fheight;
        	strcpy(txt,"Buffer 1: ");
        	strcat(txt,contents[1]);
        	l = strlen(txt);

                XDrawImageString( mydisplay,
                        my2window, my2gc,x, y,
                        txt, l);

	 }
	 
	XFlush(mydisplay);

}

win2_prompt()
{
int i,x,y,l;
char txt[50];

/*
 
           puts question if it is not null
*/

        XClearWindow(mydisplay,my2window);

/* put question if set */

        if(strlen(question) > 0)
        {
                l=strlen(question);

        	x = 3;
        	y = my2hint.height-fheight;

                XDrawImageString( mydisplay,
                        my2window, my2gc,x, y,
                        question, l);

        }


}

int check_button(int x,int y)
{
/*
      returns the number of the button pressed

      using the position on the screen to determine which is pressed

      assumes menu1 and buttons[]

*/


int x1,y1,i,l;

        i=which_button(x,y);

        if(i > -1)
        {
                /* reverse video the button picked */

                        x1=buttons[i].x-((int)menu1.width)/2;
                        y1=buttons[i].y-((int)menu1.height)/2;

                        XFillRectangle(mydisplay,my2window,my2gc,
                                x1,y1,menu1.width,menu1.height);

                        XSetForeground(mydisplay,my2gc,mybackground);
                        XSetBackground(mydisplay,my2gc,myforeground);

                        l=strlen(buttons[i].text);
                        x1=buttons[i].x-(fwidth*l)/2;

                        XDrawImageString( mydisplay,
                                my2window, my2gc,x1, buttons[i].y,
                                buttons[i].text, l);

                        XSetForeground(mydisplay,my2gc,myforeground);
                        XSetBackground(mydisplay,my2gc,mybackground);

                        XFlush(mydisplay);
         }

         return(i);
}

int which_button(int x,int y)
{
int x1,x2,y1,y2,i;

        for(i=0;i<menu1.num_buttons;i++)
        {
                x1=buttons[i].x-(int)menu1.width/2;
                y1=buttons[i].y-(int)menu1.height/2;
                x2=buttons[i].x+menu1.width/2;
                y2=buttons[i].y+menu1.height/2;
                if(x >= x1 && x <= x2 && y>=y1 && y<= y2 )
                {
                        return(i);
                }
        }

        return(-1);
}

set_buttons(int *xsize,int *ysize)
{
/*
           These are the main menu buttons

           fills the buttons structure with evenly spaced buttons

           sets all sizes for the buttons and returns the total
           window size needed

           assumes menu1 and buttons[]

*/
int i,border;

/* fill in button names here */

/*
char *names[]={"Menu","Trace","Smooth","Edit pix","Buffer 1","Quit"};
*/
char names[10][20];

        strcpy(names[0],"Menu");

        strcpy(names[1],"Trace");

#ifdef LOGISCAN	
        if(scan == 1)
        {
                strcpy(names[1],"Scan");
        }
#endif

#ifdef SVIDEO        
        if(grab_on == 1)
        {
                strcpy(names[1],"Grab");
        }
#endif

        strcpy(names[2],"Smooth");
        strcpy(names[3],"Edit Pix");
        strcpy(names[4],"Buffer 1");
        strcpy(names[5],"Quit");

        menu1.num_buttons = 6;  /* number of buttons named above */

	fill_buttons(names);
	
	border = 5;
          
        *ysize=menu1.height+2*border;
        *xsize=buttons[menu1.num_buttons-1].x+menu1.width/2+border;

}

set_buttons_trace()
{
/*
           this is the menu for inside tracing routines

           fills the buttons structure with evenly spaced buttons

           sets all sizes for the buttons

           assumes menu1 and buttons[]

*/
int i;

/* fill in button names here */

char names[10][20];

        strcpy(names[0],"Done");
        strcpy(names[1],"Direction");
        strcpy(names[2],"Limits");
        strcpy(names[3],"Settings");
        strcpy(names[4],"Delete");
        strcpy(names[5],"Save");
        strcpy(question,"");

          menu1.num_buttons = 6;  /* number of buttons named above */

         fill_buttons(names);

}

set_buttons_edit()
{
/*
           this is the menu for inside edit routines

           fills the buttons structure with evenly spaced buttons

           sets all sizes for the buttons

           assumes menu1 and buttons[]

*/
int i,border;

/* fill in button names here */

char names[10][20];

        strcpy(names[0],"Done");
        strcpy(names[1],"White");
        strcpy(names[2],"Black");
        strcpy(names[3],"Set Color");
        strcpy(names[4],"Brush Size");
        strcpy(question,"");

        menu1.num_buttons = 5;  /* number of buttons named above */

        fill_buttons(names);

}

set_buttons_question(int k)
{
/*
        sets up menu button defs for get_answer()

        set the question variable in calling routine

        k == 1 : yes/no
        K == 2 : brush size: 0,1,2,3,4,5
	 k == 3 : type of smoothing

*/
char names[10][20];

        if(k == 1)
        {
                strcpy(names[0],"yes");
                strcpy(names[1],"no");
                menu1.num_buttons = 2;  /* number of buttons named above */

        }

        if(k == 2)
        {
                strcpy(names[0],"0");
                strcpy(names[1],"1");
                strcpy(names[2],"2");
                strcpy(names[3],"3");
                strcpy(names[4],"4");
                strcpy(names[5],"5");
                menu1.num_buttons = 6;  /* number of buttons named above */
                strcpy(question,"");

        }

        if(k == 3)
        {
                strcpy(names[0],"Binary");
                strcpy(names[1],"Normal");
                strcpy(names[2],"Bin on Ave");
                strcpy(names[3],"Horz");
                strcpy(names[4],"Vertical");
                menu1.num_buttons = 5;  /* number of buttons named above */
                strcpy(question,"");

        }
        

        fill_buttons(names);

}

fill_buttons(char names[10][20])
{
int i,border;
/*
        fill the button structure with the menu names

*/
          menu1.width = 10*fwidth;
          menu1.height = (5*fheight)/2;
          border = 5;

          for(i = 0;i < menu1.num_buttons;i++)
          {
               buttons[i].x = (menu1.width+border)*i+menu1.width/2+border;
               buttons[i].y = menu1.height/2+border;

               strcpy(buttons[i].text,names[i]);

          }
}

int get_answer()
{
int done,i,q;
char txt[20];
/*
        gets answer to question via menu buttons

        includes event loop with redraw for menu only

        set menu with set_buttons_question(k)

        includes menu event loop:
                    returns the button number pressed (0 ->  menu1.num_buttons)

        set the question variable in calling routine

*/
        done = 0 ;

        while( done == 0) {
          /* read the next event */
          XNextEvent(mydisplay, &myevent);

/**********************************************************

        second window events (menu choices )

**************************************************************/
          if(myevent.xany.window == my2window)
          {
                switch(myevent.type){
                        /* repaint window on expose events */
                        case Expose:
                             if(myevent.xexpose.count == 0) draw_buttons();
                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
         /* tws: fixed error in 1st arg &myevent --> &myevent.xmapping */
                             XRefreshKeyboardMapping(&myevent.xmapping);
                        break;

                        case LeaveNotify:
                                             XClearWindow(mydisplay,my2window);
                                             draw_buttons();
                                             q = -1;
                        break;

                        case MotionNotify:
                                if(q != -1)
                                {
                                        if(q != which_button(myevent.xmotion.x,myevent.xmotion.y) )
                                        {
                                             XClearWindow(mydisplay,my2window);
                                             draw_buttons();
                                             q = -1;
                                        }
                                  }
                        break;

                        /* process mouse-button presses */
                        case ButtonPress:

                               q=check_button(myevent.xbutton.x,
                                              myevent.xbutton.y);

                               if(q != -1 )  /* menu choice was made */
                               {
                                        done = -1; /* got answer */
                               }

                        break;

                        /* process keyboard input */
                        /* should add key short cuts here need to pass array */
                        case KeyPress:
                                i = XLookupString( &myevent.xkey, txt, 10, &mykey, 0);
                                    if( i == 1 && txt[0] == 's') quicksave();
                        break;


                } /* switch(myevent.type) */
         } /* end of second window if */

        } /* while(done == 0) */

        return(q);
}



/*******************************************************************

              Fringe tracing routines

********************************************************************/

int auto_trace()
{
        float old_fringe;
        int test,save_row,save_col,x,y,answer;
        char q;

/*      needs to redraw the image if bin_lev<>0 and
        call def_olut to set up usr_lut


        should have a check to see if we need the redraw here ...
        don't need it if we are not changing usr_lut[]
*/

        if(max_row == -1)  /* define limits if they aren't set already */
        {
                max_row = height - 5;
                min_row = 4;
                max_col = width - 5;
                min_col = 4;
        }

        if( bin_lev > 0 )
        {
        	def_olut_trace();
        	newimage=1;
        	redraw();
        }

        set_buttons_trace();  /* set buttons to trace choices */
        draw_buttons();

        step_fringe=.5;

        if(last_fringe == 999.0 )
        {
                fringe=0.;
        }
        else
        {
                printf("The fringe number of the last fringe traced was %f \n\n",last_fringe);
                fringe=last_fringe;
        }

        get_default_f("Enter starting fringe number",&fringe);

        get_default_f("Enter fringe step",&step_fringe);

        old_fringe=fringe-step_fringe;

        dir_index_set=get_direction();

        draw_limits();
        draw_trace_curves(0);

        do
        {
                printf("\nTrace fringe number %f\n\n",fringe);
again:          test=trace();
                if(fringe != old_fringe)
                {
                        old_fringe=fringe;
                        save_row=start_row;
                        save_col=start_col;
                }
                if(test == 1)
                {
                        XFlush(mydisplay);  /* make sure cursor changes back  */
                        start_row=yp[old_pts-1];  /* save last pt location */
                        start_col=xp[old_pts-1];
                        save();
                        printf("\nContinue tracing fringe number %f\n\n",fringe);
                        goto again;
                }
                if(test == 2)
                {
                        XFlush(mydisplay);
/*                        
                        q = 'y';
                        get_default_c("Continue with this fringe (y/n) ",&q);
                        if( (q == 'Y')||(q == 'y') )
*/
                        sprintf(question,"Continue with this fringe?");
                        set_buttons_question(1);
                        draw_buttons();
                        answer = get_answer();
                        set_buttons_trace();
                        draw_buttons();

                        if( answer == 0 )
                        {
                                printf("\nContinue tracing fringe number %f\n\n",fringe);
                                goto again;
                        }
                        else
                        {
                                test = 0; /* continue as if ok */

                        }
                }
                start_row=save_row;
                start_col=save_col;
                fringe=fringe+step_fringe;
        }
        while( test == 0 );

        last_fringe=fringe-2*step_fringe;

        set_buttons(&x,&y);   /* put buttons back to main menu */
        draw_buttons();

}

mark_position(int row,int col)
{
/*
        X marks the spot ...

        also saves the marked position in mark_row and mark_col
        for redraw_trace

*/
int x1,x2,y1,y2;

            XSetForeground(mydisplay,mygc,color_pix);

            x1=col-5;
            x2=col+5;
            y1=row;
            y2=row;

            double_line(x1,y1,x2,y2);

            x1=col;
            x2=col;
            y1=row+5;
            y2=row-5;

            double_line(x1,y1,x2,y2);

            XSetForeground(mydisplay,mygc,myforeground);

            mark_row=row;   /* save position for redraws */
            mark_col=col;

}

int trace()
{
        int row,col,message,new_row,new_col,pts,q,exit;
        int a_row[10],a_col[10],test,end_index,dir_index;
        int temp_pts,retcode,dir_step;

        dir(a_row,a_col);

        retcode = 0;
        message = 0;
        pts=0;

        printf("Move cursor to starting point (q = quit)\n");

        if(start_row != -1 )
        {
                 mark_position(start_row,start_col);
        }

again:  if(get_pos_trace(&row,&col) == -1 ) return(-1);

        if((row > max_row)||(row<min_row)||(col<min_col)||(col>max_col))
        {
                printf("Outside limits \n");
                message = 0;
                goto again;
        }

        if(find_edge(&row,&col) != 1)
        {
                printf("Edge not found \n");
                goto again;
        }

        if(get_pix(row,col) != 255)
        {
                printf("Starting pixel not set, try again\n");
                message = 0;
                goto again;
        }
        if(test_edge(row,col) != 1)
        {
                printf("Starting pixel not on edge, try again\n");
                message = 0;
                goto again;
        }

        start_row=row;
        start_col=col;

        if(use_end_pt == 1)
        {

             if( old_pts == 0)
             {
                     end_row = start_row;
                     end_col = start_col;
             }

             printf("Move cursor to ending point (q = quit)\n");

again2:      if(get_pos_trace(&row,&col) == -1 ) return(-1);
             if((row > max_row)||(row<min_row)||(col<min_col)||(col>max_col))
             {
                     printf("Outside limits \n");
                     message = 0;
                     goto again2;
             }

             if(find_edge(&row,&col) != 1)
             {
                     printf("Edge not found \n");
                     goto again;
             }

             if(get_pix(row,col) != 255)
             {
                     printf("Ending pixel not set, try again\n");
                     message = 0;
                     goto again2;
             }
             if(test_edge(row,col) != 1)
             {
                     printf("Ending pixel not on edge, try again\n");
                     message = 0;
                     goto again2;
             }

             end_row=row;
             end_col=col;
        }

        pts = old_pts;  /* need it here ... get_pos_trace can save/delete data */

        row=start_row;
        col=start_col;

        dir_index=dir_index_set;

        new_row = row + a_row[sub_index(dir_index,-2)];
        new_col = col + a_col[sub_index(dir_index,-2)];

        if(get_pix(new_row,new_col) == 0 )
        {
             dir_step = 1;
        }
        else
        {
             dir_step = -1;
        }

        exit = 0;

        xp[pts]=col;
        yp[pts]=row;
        zp[pts]=fringe;

        if( (zp[pts-1] != fringe)||(pts == 0) )
        {
              invec[pts]=0;
        }
        else
        {
              invec[pts]=1;
        }

        pts+=1;
        temp_pts=0;

        do
        {

                dir_index = sub_index(dir_index,-2*dir_step);

                end_index = sub_index(dir_index,5*dir_step);

                do
                {

                new_row = row + a_row[dir_index];
                        new_col = col + a_col[dir_index];

                        test=test_edge(new_row,new_col);

                        if(test == 0 ) dir_index = sub_index(dir_index,dir_step);

                }
                while((dir_index != end_index) && (test == 0) );

                if(test == 1)
                {
                        row = new_row;
                        col = new_col;
                        temp_pts += 1;
                        if(temp_pts == freq_pts)
                        {
                                xp[pts]=col;
                                yp[pts]=row;
                                zp[pts]=fringe;
                                invec[pts]=1;
                                pts += 1;
                                temp_pts = 0;

                                if(pts == max_pts)
                                {
                                        exit = 1;
                                        printf("Arrays full \n");
                                        retcode=1;
                                }
                        }

                }

                if((row > max_row)||(row < min_row)||(col>max_col)||(col<min_col))
                {
                        printf("Limits reached\n");
                        exit=1;
                }

                if((end_row == row) && (end_col == col) && (use_end_pt==1)) exit = 1;

                if((start_row == row) && (start_col == col) && (pts != old_pts+1)) exit = 2;

        }
        while((test == 1) && (exit == 0) );

        if(test == 0)
        {
                printf("Cannot continue \n");
                retcode = 2;
        }

        if((start_row == row) && (start_col == col))
        {
                printf("Loop closed \n");
        }

        if((end_row == row) && (end_col == col) && (use_end_pt==1))
        {
                printf("End point reached \n");
        }

        if(exit == 1)  /* was exit = 1 BUG found! */
        {
                xp[pts]=col;
                yp[pts]=row;
                zp[pts]=fringe;
                invec[pts]=1;
                pts +=1;
        }

        printf("%i points in storage \n",pts);

        q=old_pts;

        old_pts = pts;
/*
        if(test == 1) draw_trace_curves(q);
*/
        draw_trace_curves(q);

        return(retcode);

}

int get_direction()
{
int dir_index;

        printf("\n\n\t5  6  7\n");
        printf("\t4  +  0\n");
        printf("\t3  2  1\n\n");
again3: printf("Enter beginning direction (0-7) = ? ");
        scanf("%i",&dir_index);
        getchar();
        if((dir_index > 7) || (dir_index < 0)) goto again3;

        return(dir_index);
}


int sub_index(int index,int delta)
{
/*
        does a modulo 8 on the index + delta accounting for negative
        values
*/
        int ans;
        ans = index + delta;
        if(ans < 0 ) ans = ans + 8;
        ans = ans%8;
        return(ans);
}

int dir(int a_row[],int a_col[])
{
/*
        gives the DIRection offsets to the rows and cols for the 8
        (0-7) possible directions to the next pixel
*/
        a_row[0] = 0;
        a_col[0] = 1;
        a_row[8] = 0;
        a_col[8] = 1;

        a_row[1] = 1;
        a_col[1] = 1;
        a_row[9] = 1;
        a_col[9] = 1;

        a_row[2] = 1;
        a_col[2] = 0;

        a_row[3] = 1;
        a_col[3] = -1;

        a_row[4] = 0;
        a_col[4] = -1;

        a_row[5] = -1;
        a_col[5] = -1;

        a_row[6] = -1;
        a_col[6] = 0;

        a_row[7] = -1;
        a_col[7] = 1;
}

int test_edge(int row,int col)
{
/*
        tests to see if the pixel is on a white/black edge.

        1 = on edge
*/
        int pix1,pix2,pix3,pix4,pix,test;

        pix=get_pix(row,col)/255;

        if(pix != 1) return(0);

        pix3=get_pix(row,col+1)/255;
        pix4=get_pix(row,col-1)/255;
        pix1=get_pix(row+1,col)/255;
        pix2=get_pix(row-1,col)/255;

        test = pix && ((!pix1) || (!pix2) || (!pix3) || (!pix4) );

        return(test);
}

int find_edge(int *row,int *col)
{
/*
       searches for the edge nearest to the given point

*/
int r_old,c_old,r,c,offset;

        r_old=*row;
        c_old=*col;


        if(test_edge(r_old,c_old) == 1) return(1);

        offset = 1;

again:
/*
                    X X X X
    check  x's      0     0
                    0     0
                    0 0 0 0
*/
        r=r_old-offset;
        for(c=c_old-offset;c<=c_old+offset;c++)
        {
              if(test_edge(r,c) == 1)
              {
                        *row=r;
                        *col=c;
                        return(1);
               }
        }
/*
                    O O O O
    check  x's      0     0
                    0     0
                    X X X X
*/
        r=r_old+offset;
        for(c=c_old-offset;c<=c_old+offset;c++)
        {
              if(test_edge(r,c) == 1)
              {
                        *row=r;
                        *col=c;
                        return(1);
               }
        }
/*
                    X O O O
    check  x's      X     0
                    X     0
                    X 0 0 0
*/
        c=c_old-offset;
        for(r=r_old-offset;r<=r_old+offset;r++)
        {
              if(test_edge(r,c) == 1)
              {
                        *row=r;
                        *col=c;
                        return(1);
               }
        }
/*
                    O O O X
    check  x's      O     X
                    O     X
                    O 0 0 X
*/
        c=c_old+offset;
        for(r=r_old-offset;r<=r_old+offset;r++)
        {
              if(test_edge(r,c) == 1)
              {
                        *row=r;
                        *col=c;
                        return(1);
               }
        }

        if(offset<5)
        {
                offset+=1;
                goto again;
        }

        return(-1);
}

int delete()
{
/*
        Deletes the last fringe in storage
*/
        int new_end,num_del;

        if( old_pts == 0 ) return(0);

        num_del = 0;
        new_end = old_pts-1;

        while(invec[new_end] != 0 )
        {
                new_end -= 1;
                num_del += 1;
                if( new_end == 1 )
                {
                        old_pts = 0;
                        printf("All data deleted\n");
                        last_fringe = zp[0];
                        fringe=last_fringe+step_fringe;
                        return(1);

                }
        }
        old_pts = new_end;
        printf("Fringe number %f deleted (%i points)\n",zp[old_pts],num_del);
        printf("%i points in storage \n",old_pts);

        last_fringe = zp[old_pts -1];  /* reset to previous fringe number */
        fringe=last_fringe+step_fringe;
}


int save()
{
/*
        writes the data out to a GF file.  Note if write error occurrs
        then data isn't lost.
*/
        int q,np;

        if(old_pts == 0)
        {
                printf("No points in storage \n");
                return(-1);
        }

        printf("%i points in storage \n",old_pts);
        q=1;
        get_default_i("Enter Store(1), Discard(2), Exit(0)",&q);

        if( q == 1 )
        {
                np=old_pts;

                if(gffile(np) != -1) old_pts = 0;

        }

        if( q == 2 )
        {
                old_pts = 0;
        }

        printf("%i points in storage \n",old_pts);
}


int set_limits()
{
/*
        Set the tracing limits using the cursor on the screen.
*/
        int row1,row2,col1,col2;

        printf("Move cursor to upper left corner limit (q = quit)\n");
        if(get_pos(&row1,&col1) == -1 ) return(-1);

        printf("Move cursor to lower right corner limit (q = quit)\n");

        if(get_pos(&row2,&col2) == -1 ) return(-1);

        if((row1 >= row2) || (col1 >= col2))
        {
                printf("Invalid limits \n");
                return(-1);
        }

        max_row=row2;
        min_row=row1;
        max_col=col2;
        min_col=col1;

        printf("New limits set\n\n");
}

int draw_limits()
{
int width,height,x,y;

          XSetForeground(mydisplay,mygc,color_pix);

          width = max_col-min_col;
          height = max_row-min_row;

          XDrawRectangle(mydisplay,mywindow,mygc,
                        min_col,min_row,width,height);

          width=width-2;
          height=height-2;
          x=min_col+1;
          y=min_row+1;

          XDrawRectangle(mydisplay,mywindow,mygc,x,y,width,height);

          XSetForeground(mydisplay,mygc,myforeground);
}

int set_pars()
{
int temp_bin;

        get_default_i("Enter point storage frequency ( >= 1)",&freq_pts);
        if(freq_pts<1) freq_pts = 1;

        temp_bin=bin_lev;
        get_default_i("Enter binarization level (0 = none)",&bin_lev);
        if((bin_lev > 255)||(bin_lev <0 )) bin_lev = 0;
        def_olut_trace();
        if(temp_bin != bin_lev ) newimage = 1;

        get_default_i("Use end point to stop trace (1 = Y)",&use_end_pt);
        if(use_end_pt != 1) use_end_pt=0;

}

int get_pix(int row,int col)
{
/*
        Modified for TRACE, does binarization if bin_lev != 0

        modifed for X version

*/
        int pix;

        pix=(int)image(disbuf,row,col);

        if(bin_lev == 0)
        {
              return(pix);
        }
        else
        {
                if(pix >= bin_lev ) return(255);
                if(pix < bin_lev ) return(0);
        }

}

int put_pix(int row, int col,int level)
{
/*
        modifed for X version

*/
        putimage(disbuf,row,col,level);
}

int gffile(int numpoint)
{
/*
     function to write a GF format file
     asks for a file name
     assumes numpoint data points in
     xp[], yp[], invec[] as global variables

     adds third collumn for zp[] fringe number data

*/
        char q[10];
        int count,fchk;
        float x,y;

again:
        printf(" File name (q = quit) (.gf added) = ");
        gets(file);
        if((file[0]=='q' || file[0]=='Q') && strlen(file)==1)
        {
                return(-1);
        }

        if( strstr(file,".gf") == NULL ) strcat(file,".gf");

        if((fileprt=fopen(file,"r")) != NULL )
        {
               fclose(fileprt);
               strcpy(q,"n");
               get_default_s(" File exists, Overwrite (y/n) ",q);
               if( q[0] != 'y' && q[0] != 'Y')
               {
                     goto again;
               }
        }

        fileprt = fopen(file,"w");

        if(fileprt == NULL )
        {
                printf("Cannot open file \n");
                goto again;
        }

        fprintf(fileprt,"%4i\n",numpoint);
        for (count = 0; count < numpoint ; count++)
        {
                x=(float)xp[count];
                y=(float)yp[count];
                fchk=fprintf(fileprt,"%3i%+9.3E%+9.3E%+9.3E\n",invec[count],x,y,zp[count]);
                if(fchk==0)
                {
                        printf("***** Write Error *****");
                        fclose(fileprt);
                        return(-1);
                }
        }
        fprintf(fileprt,"+.0000E+00%+9.3E\n%+9.3E+.0000E+03\n\n\nN\n",(float)width,(float)height);
        fclose(fileprt);
        return(0);
}


int def_olut_trace()
{
/*
        modified for TRACE, defines output usr_LUT  as binarization at
        bin_lev and is used automatically.

        modified for X version

*/
        int i,map;

        for(i=0;i<256;i++)
        {
                if(bin_lev == 0 )
                {
                        map = i;
                }
                else
                {
                        if(i < bin_lev)
                        {
                              map = 0;
                        }
                        else
                        {
                              map = 255;
                        }
                }
                usr_lut[i]=map;
        }
}


int draw_trace_curves(int start)
{
/*
            X - only version

*/
int i,ivt;
int xt,yt,xold,yold;
int xx1,xx2,yy1,yy2;

       if(start >= old_pts) return(-1);

       if(old_pts<= 0) return(-1);

       XSetForeground(mydisplay,mygc,color_pix);

       xold=xp[start];
       yold=yp[start];

       for(i=start+1;i<old_pts;i++)
       {
              xt = xp[i];

              yt = yp[i];

              ivt = invec[i];

              if(ivt == 1)
              {

                  xx1=xold;
                  yy1=yold;
                  xx2=xt;
                  yy2=yt;

                  xold=xt;
                  yold=yt;

                  double_line(xx1,yy1,xx2,yy2);

             }
             else  /* start new line */
             {
                  xold=xt;
                  yold=yt;
             }

       }

       XSetForeground(mydisplay,mygc,myforeground);

       return(0);

}

double_line(int xx1, int yy1,int xx2, int yy2)
{
/*
        draws a double width line

*/

                  XDrawLine(mydisplay,mywindow,mygc,xx1,yy1,xx2,yy2);

                  if(abs(xx2-xx1) > abs(yy2-yy1))
                  {
                        yy1=yy1+1;
                        yy2=yy2+1;
                        XDrawLine(mydisplay,mywindow,mygc,xx1,yy1,xx2,yy2);
                  }
                  else
                  {
                        xx1=xx1+1;
                        xx2=xx2+1;
                        XDrawLine(mydisplay,mywindow,mygc,xx1,yy1,xx2,yy2);
                  }
}


redraw_trace()
{
        draw_limits();
        draw_trace_curves(0);
        if(mark_row != -1 ) mark_position(mark_row,mark_col);
}

int get_pos_trace(int *row,int *col)
{
int done,i,q;
char txt[20];

/*
        returns the position of  a mouse pointer click

        returns 1 if pointer clicked

        returns -1 if q pressed

        cursor changes to cross hair for input

        includes event loop with redraw and resize

        set menu with set_buttons_trace()

        includes menu event loop:
                        q = 0 is done
                        q = 1 is set direction
                        q = 2 is set limits
                        q = 3 is set parameters
                        q = 4 is delete last fringe traced
                        q = 5 is save fringe data
*/


        /* set cursor to crosshair */

        mycursor = XCreateFontCursor(mydisplay,XC_crosshair);

        XDefineCursor(mydisplay,mywindow,mycursor);



        /* event-reading loop to get cursor position */
        done = 0;
        while( done == 0) {
                /* read the next event */
          XNextEvent(mydisplay, &myevent);

          if(myevent.xany.window == mywindow)
          {
                switch(myevent.type){
                        /* repaint window on expose events */
                        case Expose:

                              if(myevent.xexpose.count == 0)
                              {
                                       redraw();
                                       redraw_trace();
                              }

                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
                        XRefreshKeyboardMapping(&myevent.xmapping);
                        break;

                        /* process mouse-button presses */
                        case ButtonPress:

                                    *col=myevent.xmotion.x;
                                    *row=myevent.xmotion.y;
                                    done = 1;

                        break;

                        /* process keyboard input */
                        case KeyPress:
                                i = XLookupString( &myevent.xkey, txt, 10, &mykey, 0);
                                if( i == 1 && txt[0] == 'q')
                                    {
                                         done = -1;
                                    printf("... aborted \n");
                                     }
                                    if( i == 1 && txt[0] == 's') quicksave();
                        break;
                } /* switch(myevent.type) */
          }
/**********************************************************

        second window events (menu choices )

**************************************************************/
          if(myevent.xany.window == my2window)
          {
                switch(myevent.type){
                        /* repaint window on expose events */
                        case Expose:
                        if(myevent.xexpose.count == 0) draw_buttons();
                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
         /* tws: fixed error in 1st arg &myevent --> &myevent.xmapping */
                        XRefreshKeyboardMapping(&myevent.xmapping);
                        break;

                        case LeaveNotify:
                                             XClearWindow(mydisplay,my2window);
                                             draw_buttons();
                                             q = -1;
                        break;

                        case MotionNotify:
                                if(q != -1)
                                {
                                        if(q != which_button(myevent.xmotion.x,myevent.xmotion.y) )
                                        {
                                             XClearWindow(mydisplay,my2window);
                                             draw_buttons();
                                             q = -1;
                                        }
                                  }
                        break;

                        /* process mouse-button presses */
                        case ButtonPress:

                               q=check_button(myevent.xbutton.x,
                                              myevent.xbutton.y);

                               if(q==0)  /* first menu choice  */
                               {
                                        done = -1; /* done with tracing */
                               }
                               if(q==1)  /* get direction for tracing */
                               {
                                        dir_index_set=get_direction();
                                        printf("Pick point on fringe (q=quit) \n");
                               }
                               if(q==2)
                               {
                                        set_limits();
                                        redraw();
                                        redraw_trace();
                                        printf("Pick point on fringe (q=quit) \n");
                               }

                               if(q==3)
                               {
                                        set_pars();
                                        if(newimage == 1)
                                        {
                                                redraw();
                                                redraw_trace();
                                        }
                                        printf("Pick point on fringe (q=quit) \n");
                               }

                               if(q==4)
                               {
                                         delete();
                                         redraw();
                                         redraw_trace();
                                         printf("Pick point on fringe (q=quit) \n");
                               }
                               if(q ==5)
                               {

                                         save();

                                         redraw();
                                         redraw_trace();
                                         printf("Pick point on fringe (q=quit) \n");
                                }

                        break;
                        /* process keyboard input */
                        case KeyPress:
                                i = XLookupString( &myevent.xkey, txt, 10, &mykey, 0);
                                    if( i == 1 && txt[0] == 's') quicksave();
                        break;


                } /* switch(myevent.type) */
         } /* end of second window if */

        } /* while(done == 0) */

        /* set cursor back */

        XUndefineCursor(mydisplay,mywindow);

        return(done);
}


/*******************************************************************

                  pixel editing routines

*******************************************************************/



edit()
{
int x,y;

        set_buttons_edit();
        draw_buttons();

        cross_hair();

        get_pos_edit();

        default_cursor();

        set_buttons(&x,&y);
        draw_buttons();
}


int get_pos_edit()
{
int done,i,q,draw;
int row_start,row_end,col_start,col_end;
char txt[20];
/*
        cursor changes to cross hair for input

        includes event loop with redraw and resize

        set menu with set_buttons_edit()

        includes menu event loop:
                        q = 0 is done
                        q = 1 is set white
                        q = 2 is set black
                        q = 3 is set level
*/


        /* event-reading loop to get cursor position */
        done = 0;
        draw = 0;

        /* input event selection added button release */

        XSelectInput(mydisplay,mywindow,
             ButtonPressMask | KeyPressMask | ExposureMask |
             PointerMotionMask | ButtonReleaseMask);


        while( done == 0) {
                /* read the next event */
          XNextEvent(mydisplay, &myevent);

          if(myevent.xany.window == mywindow)
          {
                switch(myevent.type){
                        /* repaint window on expose events */
                        case Expose:

                              if(myevent.xexpose.count == 0)
                              {
                                       redraw();
                              }

                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
                        XRefreshKeyboardMapping(&myevent.xmapping);
                        break;

                        /* process mouse-button presses */
                        case ButtonPress:
                                    col_start=myevent.xmotion.x;
                                    row_start=myevent.xmotion.y;
                                    draw = 1;

                        break;

                        case ButtonRelease:
                                    col_end=myevent.xmotion.x;
                                    row_end=myevent.xmotion.y;
                                    fill_line(brush_level,row_start,row_end,col_start,col_end);
                                    newimage=1;
                                    draw = 0;
                         break;

                         case MotionNotify:
                                    if(draw==1)
                                    {
                                        col_end=myevent.xmotion.x;
                                        row_end=myevent.xmotion.y;
                                        fill_line(brush_level,row_start,row_end,col_start,col_end);
                                        col_start=col_end;
                                        row_start=row_end;
                                        newimage=1;
                                     }
                         break;


                        /* process keyboard input */
                        case KeyPress:
                                i = XLookupString( &myevent.xkey, txt, 10, &mykey, 0);
                                if( i == 1 && txt[0] == 'q')
                                    {
                                         done = -1;
                                    printf("... aborted \n");
                                     }
                                if( i == 1 && txt[0] == 's' ) quicksave();
                        break;
                } /* switch(myevent.type) */
          }
/**********************************************************

        second window events (menu choices )

**************************************************************/
          if(myevent.xany.window == my2window)
          {
                switch(myevent.type){
                        /* repaint window on expose events */
                        case Expose:
                        if(myevent.xexpose.count == 0) draw_buttons();
                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
         /* tws: fixed error in 1st arg &myevent --> &myevent.xmapping */
                        XRefreshKeyboardMapping(&myevent.xmapping);
                        break;

                        case LeaveNotify:
                                             XClearWindow(mydisplay,my2window);
                                             draw_buttons();
                                             q = -1;
                        break;

                        case MotionNotify:
                                if(q != -1)
                                {
                                        if(q != which_button(myevent.xmotion.x,myevent.xmotion.y) )
                                        {
                                             XClearWindow(mydisplay,my2window);
                                             draw_buttons();
                                             q = -1;
                                        }
                                  }
                        break;

                        /* process mouse-button presses */
                        case ButtonPress:

                               q=check_button(myevent.xbutton.x,
                                              myevent.xbutton.y);

                               if(q==0)  /* first menu choice  */
                               {
                                        done = -1; /* done with editing */
                               }
                               if(q==1)  /* set to white level */
                               {
                                         brush_level = 255;
                               }
                               if(q==2) /* set to black level */
                               {
                                         brush_level = 0;
                               }

                               if(q==3)  /* get brush level */
                               {

                                        get_default_i("Enter the brush level desired (0-255) ",&brush_level);
                               }

                               if(q==4)  /* get brush size */
                               {
/*
                                        get_default_i("Enter the brush size desired (0-5) ",&brush);
*/
                                        set_buttons_question(2);
					sprintf(question,"Select brush size");
                                        draw_buttons();
                                        brush=get_answer();
                                        set_buttons_edit();
                                        draw_buttons();
                               }


                        break;

                        /* process keyboard input */
                        case KeyPress:
                                i = XLookupString( &myevent.xkey, txt, 10, &mykey, 0);
                                    if( i == 1 && txt[0] == 's') quicksave();
                        break;


                } /* switch(myevent.type) */
         } /* end of second window if */

        } /* while(done == 0) */

        /* input event selection */
        XSelectInput(mydisplay,mywindow,
             ButtonPressMask | KeyPressMask | ExposureMask |
             PointerMotionMask);


        return(done);
}





fill_line(int level,int last_row,int new_row,int last_col,int new_col)
{
/*
        does the brush width drawing on the screen between 2 points.

         modified for X version,  changes data in array and draws the line
        on the screen.

         crops to image size

*/
        int np_col,np_row,np,i,j,k,icol,irow;
        float drow,dcol,row,col;
 /*       int abs();   don't need ? */

        np_col=abs(last_col-new_col);
        np_row=abs(last_row-new_row);

        np=np_col;
        if(np_row > np_col) np=np_row;

        if(np == 0) return(1);

        drow=((float)(new_row-last_row))/((float)np);
        dcol=((float)(new_col-last_col))/((float)np);

        col=(float)last_col;
        row=(float)last_row;

        XSetForeground(mydisplay,mygc,lut[level]);

        for(k=0;k<np;k++)
        {
            col= col + dcol;
            row= row + drow;
            icol=(int)col;
            irow=(int)row;
            for(i=irow-brush;i<irow+brush+1;i++)
            {
               for(j=icol-brush;j<icol+brush+1;j++)
               {
                        if( (i < height) && (i >= 0 )&& (j < width) && (j >= 0))
                        {
                                put_pix(i,j,level);

                                XDrawPoint(mydisplay,mywindow,mygc,j,i);
                        }
               }
            }
        }

        XSetForeground(mydisplay,mygc,myforeground);

}



/*******************************************************************

                 smoothing and math routines

*******************************************************************/

int smooth()
{
        int row1,row2,col1,col2,pix,h_or_v,ans;
        int test1,test2,test,i,j,ave,smooth_type,n_pix;
        int w_size;
        float a,b,c;
        char q1[10],txt[100];

        source=disbuf;
        target=1-disbuf;

        printf("Current display buffer = %i\n",disbuf);
/*
        printf("\n*** OTHER BUFFER WILL BE OVER WRITTEN ***\n");

        strcpy(q1,"n");
        get_default_s("Continue with Smoothing (y/n)",q1);
        if( q1[0]=='n' || q1[0]=='N' )
        {
                return(0);
        }
*/
	 set_buttons_question(1);  /* yes / no */
	 sprintf(question,"OTHER BUFFER WILL BE OVER WRITTEN, Continue?");
	 draw_buttons();
	 ans=get_answer();
        if( ans == 1 )
        {
		  set_buttons(&i,&j);
		  draw_buttons();
		  return(0);
        }

        printf("Making copy of image...\n");
        copy_image();

again2:  smooth_type=1;
/*
         get_default_i("Enter choice: 1=Binary smth, 2=Smooth, 3=Bin on ave 4=H/V smth",&smooth_type);

        if((smooth_type < 0)||(smooth_type > 4))
        {
                printf("*** reenter ***");
                goto again2;
        }
*/
	 set_buttons_question(3);
	 sprintf(question,"Pick smoothing type");
	 draw_buttons();
	 smooth_type = get_answer() + 1;


        if(smooth_type == 2)
        {
                printf("Pij = A Mij + B + C (Pij - Mij) \n");
                a=1.0;
                b=0.0;
                c=0.0;
                get_default_f("Input A ",&a);
                get_default_f("Input B ",&b);
                get_default_f("Input C ",&c);
        }
        if(smooth_type == 3)
        {
                printf("Test value = A Mij + B \n");
                a=1.0;
                b=0.0;
                get_default_f("Input A ",&a);
                get_default_f("Input B ",&b);
        }
        if(smooth_type >= 4)
        {
                h_or_v=1;
/*
                get_default_i("Horizontal(1) or Vertical(2) ",&h_or_v);
*/
		  if(smooth_type == 5)
		  {
			 h_or_v = 2;
			 smooth_type = 4;
		  }
        }

        window=3;
/*
        get_default_i("Enter smoothing window half size (1-5) ",&window);
*/
	 set_buttons_question(2);
	 sprintf(question,"Enter smoothing window half size");
	 draw_buttons();
	 window = get_answer();
	 printf("\n");
	 set_buttons(&i,&j);
	 draw_buttons();

        if(window > 5 ) window = 5;
        if(window < 1 ) window = 1;

again:  

printf("Move cursor to upper left corner of area to smooth (q = quit)\n");
        cross_hair();
        test=get_pos(&row1,&col1);
        default_cursor();
        if(test == -1 ) return(-1);

        printf("Move cursor to lower right corner of area to smooth (q = quit)\n");
        cross_hair();
        if(get_pos(&row2,&col2) == -1 ) return(-1);
        default_cursor();
        if((row1 >= row2) || (col1 >= col2))
        {
                printf("Invalid area \n");
                goto again;
        }

        printf("Working ... \n");

        if( row1 < window+1 ) row1=window+1;
        if( col1 < window+1 ) col1=window+1;
        if( row2 > height-window-2 ) row2=height-window-2;
        if( col2 > width-window-2 ) col2=width-window-2;

        pix = 0;

         w_size=2*window+1;
         n_pix=w_size*w_size;
         test1=(w_size*w_size-2)*128;
         test2=(w_size*w_size)*128;

         for(i=row1;i<row2+1;i++)
         {
             if( smooth_type == 1)
             {
                 run_sum = -1;
                 for(j=col1;j<col2+1;j++)
                 {
                          pix=(int)image(source,i,j);
                          test=sum_win(i,j)-pix;
                          if(test >= test2) pix = 255;
                          if(test <= test1) pix = 0;

                          putimage(target,i,j,pix);
                 }
             }
             if( smooth_type == 2)
             {
                 run_sum = -1;
                 for(j=col1;j<col2+1;j++)
                 {
                          pix=(int)image(source,i,j);
                          ave=sum_win(i,j)/n_pix;
                          pix=a*ave+b+c*(pix-ave);
                          if(pix > 255) pix = 255;
                          if(pix < 0) pix = 0;

                          putimage(target,i,j,pix);

                 }
             }
             if( smooth_type == 3)
             {
                 run_sum = -1;
                 for(j=col1;j<col2+1;j++)
                 {
                          pix=(int)image(source,i,j);
                          ave=sum_win(i,j)/n_pix;
                          test=a*ave+b;
                          if(pix >= test) pix = 255;
                          if(pix < test) pix = 0;

                          putimage(target,i,j,pix);

                 }
             }
             if( smooth_type == 4)
             {
                 for(j=col1;j<col2+1;j++)
                 {
                          if(h_or_v == 1) ave=sum_win_h(i,j);
                          if(h_or_v != 1) ave=sum_win_v(i,j);
                          pix=ave/w_size;
                          if(pix > 255) pix = 255;
                          if(pix < 0) pix = 0;

                          putimage(target,i,j,pix);

                 }
             }

         }
         disbuf=target;
         set_buffer();

         printf("Smoothing done, showing result ... \n");

        strcpy(txt,"s: ");
        strcat(txt,contents[source]);

        strcpy(contents[target],txt);

/*
         update the screen image

*/
         newimage=1;
         redraw();

}


int sum_win_h(int row,int col)
{
        int j,sum;
        sum = 0;
                for(j=col-window;j<col+window+1;j++)
                {
                     sum = sum + (int)image(source,row,j);
                }
        return(sum);
}

int sum_win_v(int row,int col)
{
        int j,sum;
        sum = 0;
                for(j=row-window;j<row+window+1;j++)
                {
                     sum = sum + (int)image(source,j,col);
                }
        return(sum);
}


int sum_win(int row, int col)
{
/*
        calculates the sum of the pixel values in the window
*/
        int i,j,sum,j1,j2;
        if(run_sum == -1)
        {
             sum = 0;

             for(i=row-window;i<row+window+1;i++)
             {
                for(j=col-window;j<col+window+1;j++)
                {
                     sum = sum + (int)image(source,i,j);
                }
             }
        }
        else
        {
             sum=run_sum;

             j1=col-window-1;
             j2=col+window;
             for(i=row-window;i<row+window+1;i++)
             {
                sum = sum - (int)image(source,i,j1) + (int)image(source,i,j2);
              }
        }

        run_sum=sum;

        return(sum);
}

int copy_image()
{
/*
        copies the image from one buffer to another

        smoothX version
*/
int i,j;
        for(i=0;i<width;i++)
        {
               for(j=0;j<height;j++)
               {

                     putimage(target,j,i,(int)image(source,j,i));

               }
        }
}

int level_frame()
{
/*
        levels out the illumination in an image by adjusting the average
        value in a block to 128.  Block size must divide evenly into
        both image dimensions and be even.
*/
        int i,j,blk_size,pix,blk_size_d2;
        int flag,imin,jmin;
        int nblks_w,nblks_h,jave,jend,iave,iend;
        float img_ave,rblk_size,t1,t2,tave;
        float *avei,*aver;
        /*
        avei and aver are used as the declaration below
            avei = average in the image of each block
            aver = average in the row for appropriate blocks

        float avei[50][50],aver[50];
        */
        char q1[10],txt[100];

        source=disbuf;
        target=1-disbuf;

        printf("Current display buffer = %i\n",disbuf);

        printf("\n*** OTHER BUFFER WILL BE OVER WRITTEN ***\n");

        strcpy(q1,"n");
        get_default_s("Continue with filtering (y/n)",q1);
        if( q1[0]=='n' || q1[0]=='N' )
        {
                return(0);
        }

again2:  blk_size=32;
         get_default_i("Enter block size ",&blk_size);

         flag=0;
         if(width != blk_size*((int)(width/blk_size))) flag=1;
         if(height != blk_size*((int)(height/blk_size))) flag=1;
         if(flag == 1)
         {
                printf("Block size number must divide evenly into image size\n");
                goto again2;
         }
         if(blk_size != 2*((int)(blk_size/2)))
         {
                printf("Block size must be even \n");
                goto again2;
         }

        printf("Working ... \n");
/*
        calculate the number of blocks in each direction
*/

        nblks_w=width/blk_size;
        nblks_h=height/blk_size;

/*
        allocate the array storage
*/

        avei=(float *)malloc(nblks_w*nblks_h*sizeof(float));
        aver=(float *)malloc(nblks_w*sizeof(float));

        rblk_size=(float)blk_size;

/*
        zero out the average value in each block
*/

        for(i=0;i<nblks_h;i++)
        {
        for(j=0;j<nblks_w;j++)
        {
                *(avei+i*nblks_w+j)=0.;
        }
        }

/*
        calculate the average value in each block
*/

         for(i=0;i<height;i++)
         {
            iave = (int)(i/blk_size);
            for(j=0;j<width;j++)
            {

               jave = (int)(j/blk_size);
               pix=(int)image(source,i,j);
               *(avei+iave*nblks_w+jave)=*(avei+iave*nblks_w+jave)+(float)pix;
            }
         }
         printf("\n");

/*
        divide by number of pixels in each block and
        calculate image average
*/
        img_ave=0.;
        for(i=0;i<nblks_h;i++)
        {
        for(j=0;j<nblks_w;j++)
        {
          *(avei+i*nblks_w+j)=*(avei+i*nblks_w+j)/(rblk_size*rblk_size);
          img_ave=img_ave+*(avei+i*nblks_w+j);
        }
        }

        img_ave=img_ave/(nblks_w*nblks_h);
        printf(" frame average = %g \n",img_ave);

/*
        now apply the map each pixel is offset by the block average
        difference from 128, block averages are linearly interpolated
        between blocks to give a smooth map.
*/
        printf(" pass 2 \n");

         blk_size_d2=blk_size/2;
         jend=width-blk_size_d2;
         iend=height-blk_size_d2;

/*
        over all rows
*/
         for(i=0;i<height;i++)
         {

            iave = (int)(i/blk_size);
            imin = (int)((i-blk_size_d2)/blk_size);
/*
            calculate the smoothed block average for each row and
            store it in aver
*/

            for(j=0;j<nblks_w;j++)
            {

               if((i < blk_size_d2) || (i > iend))
               {
                 *(aver+j)=*(avei+iave*nblks_w+j);
               }
               else
               {
                 t1=*(avei+imin*nblks_w+j);
                 t2=*(avei+(imin+1)*nblks_w+j);
                 *(aver+j)=t1+(t2-t1)*((float)(i-imin*blk_size-blk_size_d2))/rblk_size;
               }
            }

/*
            apply the map to each pix in the row
*/

            for(j=0;j<width;j++)
            {
               jave = (int)(j/blk_size);
               jmin = (int)((j-blk_size_d2)/blk_size);

               pix=(int)image(source,i,j);

               if((j < blk_size_d2) || (j > jend))
               {
                  tave=*(aver+jave);
               }
               else
               {
                  t1=*(aver+jmin);
                  t2=*(aver+jmin+1);
                  tave=t1+(t2-t1)*((float)(j-jmin*blk_size-blk_size_d2))/rblk_size;
               }

               pix=pix-(int)tave+128;

               if(pix < 0) pix = 0;
               if(pix > 255) pix = 255;

               putimage(target,i,j,pix);

          }

        }

/*
        free up the array storage
*/
        free(avei);
        free(aver);

/*
        set display buffer to the new image and display it
*/

         disbuf=target;
         set_buffer();

         printf("Filter done, showing result ... \n");

        strcpy(txt,"l: ");
        strcat(txt,contents[source]);

        strcpy(contents[target],txt);

/*
         update the screen image

*/
         newimage=1;
         redraw();

}


int fill_box()
{
        int row1,row2,col1,col2,level;

again2: printf("\nEnter fill level = ? ");
        scanf("%i",&level);
        getchar();

        if((level > 255)||(level < 0))
        {
              printf("Level out of range 0-255 \n");
              goto again2;
        }

again:  printf("Move cursor to upper left corner of box to fill (q = quit)\n");

        cross_hair();
        if(get_pos(&row1,&col1) == -1 ) return(-1);
        default_cursor();

        printf("Move cursor to lower right corner of box to fill (q = quit)\n");

        cross_hair();
        if(get_pos(&row2,&col2) == -1 ) return(-1);
        default_cursor();

        if((row1 >= row2) || (col1 >= col2))
        {
                printf("Invalid area \n");
                goto again;
        }

        fill_box_sub(row1,row2,col1,col2,level);

        printf("Fill done \n");

        newimage=1;
        redraw();
}

int fill_box_sub(int row1, int row2, int col1, int col2, int level)
{
        int i,j;

        for(i=row1;i<row2+1;i++)
        {
            for(j=col1;j<col2+1;j++)
            {
                putimage(disbuf,i,j,level);
            }

        }

}

int def_olut()
{
/*
        modifed for X windows: fills the array usr_lut[]

*/
        int i,map,choice,level,level1;
        float a;

        printf("Choices are:\n");
        printf("0\tExit\n");
        printf("1\tBinarization\n");
        printf("2\tCut Low\n");
        printf("3\tCut High\n");
        printf("4\tReverse binarization\n");
        printf("5\tStretch map         \n");
        printf("6\tBand pass           \n");
        printf("7\tBand cut            \n");
        printf("8\tIdentity            \n");
        do
        {
        choice = 8;
        get_default_i("Enter Choice ",&choice);
        }
        while((choice <0) || (choice >8 ));
        if( choice == 0)
        {
                return(-1);
        }

        switch(choice)
        {
                case 1:
                case 4:
                        level=128;
                        get_default_i("Enter binarization level",&level);
                        break;
                case 2:
                case 3:
                        level =128;
                        get_default_i("Enter cut off level ",&level);
                        break;
                case 5:
                        printf("Xout = a (Xin - b) + c\n");
                        a=2.0;
                        level=128;
                        level1=128;
                        get_default_f("Enter a ",&a);
                        get_default_i("Enter b ",&level);
                        get_default_i("Enter c ",&level1);
                        break;
                case 6:
                case 7:
                        level = 50;
                        level1 = 205;
                        get_default_i("Enter lower level ",&level);
                        get_default_i("Enter upper level ",&level1);
                        break;
        }

        for(i=0;i<256;i++)
        {
                switch(choice)
                {
                case 1:
                        if(i < level)
                        {
                              map=0;
                        }
                        else
                        {
                              map = 255;
                        }
                        break;
                case 2:
                        map = i;
                        if(i <= level) map=0;
                        break;
                case 3:
                        map=i;
                        if(i >= level) map = 255;
                        break;
                case 4:
                        if(i <= level)
                        {
                              map=255;
                        }
                        else
                        {
                              map = 0;
                        }
                        break;
                case 5:
                        map = (int)(a*(i-level)+level1);
                        if(map >255) map=255;
                        if(map < 0 ) map= 0 ;
                        break;
                case 6:
                        map = i;
                        if(i <= level)   map=0;
                        if( i >= level1) map = 255;
                        break;
                case 7:
                        map = i;
                        if((i >= level)&&(i <= level1)) map = 0;
                        break;
                case 8:
                default:
                         map=i;
                         break;
                }

                usr_lut[i]=map;
        }

}


int math_frame()
{
/*
        Preforms either single or 2 frame operations.  Uses
        add_frames for the 2 frame operations.

        2 frame operations are done using add_frames which does the
        computations in software.  This results in a much longer
        calculation time.

        modifed for X versions


*/
        int i,i1,curr_buff,source,target,q,op,bl,j;
        float a,b,c;
         char txt[100];

        curr_buff=disbuf;

        q=1;
        get_default_i("Single frame(1) or two frame(2) math ",&q);

        switch(q)
        {
                case 1:
                default:
                        printf("New value = a ( Pij - b ) + c \n");
                        a=1.0;
                        b=128.;
                        c=128.;
                        get_default_f("Enter a ",&a);
                        get_default_f("Enter b ",&b);
                        get_default_f("Enter c ",&c);
                        bl=0;
                        get_default_i("Enter binerization level (0 = none) ",&bl);
                        break;

                case 2:
                        op=0;
                        get_default_i("Operation addition: clipped(1), averaged(2), Sub(-1) or Diff(0) ",&op);
                        break;
        }


        printf("Current display buffer = %i\n",disbuf);

again:  source=disbuf;
        get_default_i("Enter source buffer (0,1) ",&source);

        if((source != 0 ) && (source != 1))
        {
                source = disbuf;
        }

        target=1-disbuf;
        get_default_i("Enter target buffer (0,1) ",&target);

        if((target != 0 ) && (target != 1))
        {
                target = 1-disbuf;
        }
        if((target == source )&&(q == 2))
        {
                printf("Source and target equal \n");
                goto again;
        }

        printf("Working ... \n");

        switch(q)
        {
                case 1:
                        for(i=0;i<width;i++)
                        {
                                for(j=0;j<height;j++)
                                {
                                        i1=a*((int)image(source,j,i) - b) + c;
                                        if(i1 > 255) i1=255;
                                        if(i1 < 0) i1=0;

                                        if(bl > 0 ) /* do binarization */
                                        {
                                                if(i1 >= bl ) i1=255;
                                                if(i1 < bl ) i1=0;
                                        }

                                        putimage(target,j,i,i1);
                                }
                        }

                break;

                case 2:
                        add_frames(source,target,op);
                break;
        }

        disbuf=target;
        set_buffer();
        newimage=1;
        redraw();

        printf("Done        \n");

        strcpy(txt,"m: ");
        strcat(txt,contents[source]);

        strcpy(contents[target],txt);

}

int add_frames(int source,int target,int operation)
{
/*
        Software 8 bit addition/subtraction with or without averaging
        and offsetting.  Called by math_frame.  Note source and target
        must be different.  Results are stored in the target buffer.

        modified for X versions

*/
        int i1s,i1t,s,d,i,c,j;

        switch(operation)
        {
                case -1:           /* subtraction           */
                        s = -1;
                        d = 1;
                        c=128;
                        break;
                case 0:           /* difference            */
                        s = -1;
                        d = 2;
                        c=128;
                        break;
                case 1:           /* addition and clipping */
                        s = 1;
                        d = 1;
                        c=0;
                        break;
                case 2:           /* addition and divide by 2 */
                        s = 1;
                        d = 2;
                        c=0;
                        break;
                default:
                        s = 1;
                        d = 1;
                        break;
        }

        for (i=1;i<width;i++)
        {
            for (j=1;j<height;j++)
            {
                   i1t=(int)image(target,j,i);

                   i1s=(int)image(source,j,i);

                   i1t=(i1t+s*i1s)/d + c;

                   if(i1t > 255)
                   {
                        i1t = 255;
                   }
                   if(i1t < 0)
                   {
                        i1t = 0;
                   }

                   putimage(target,j,i,i1t);
            }
        }
}

int offset_frame()
{
/*
        offsets a frame in the x and y directions and applies a
        rotation about a point

        modifed for X versions


*/
        int i,curr_buff,source,target,j;
        float ct,st;
        int x0,y0,x1,y1,y2,x2,x3,y3,dx,dy;
        int v1x,v1y,v2x,v2y,inew,jnew;
        float mv1,mv2,theta;
        char q1[5];

        curr_buff=disbuf;


        printf("\n*** OTHER BUFFER WILL BE OVER WRITTEN ***\n");

        strcpy(q1,"n");
        get_default_s("Continue with Offset (y/n)",q1);
        if( q1[0]=='n' || q1[0]=='N' )
        {
                return(0);
        }

        printf("Enter current points coords \n");
        printf("Point 1   row = ? ");
        scanf("%i",&y0);
        printf("Point 1   col = ? ");
        scanf("%i",&x0);
        printf("Point 2   row = ? ");
        scanf("%i",&y1);
        printf("Point 2   col = ? ");
        scanf("%i",&x1);
        printf("Enter desired points coords \n");
        printf("Point 1   row = ? ");
        scanf("%i",&y2);
        printf("Point 1   col = ? ");
        scanf("%i",&x2);
        printf("Point 2   row = ? ");
        scanf("%i",&y3);
        printf("Point 2   col = ? ");
        scanf("%i",&x3);
        getchar();

        dx=x2-x0;
        dy = y2 - y0;

        v1x=x1+dx-x2;
        v1y=y1+dy-y2;

        v2x=x3-x2;
        v2y=y3-y2;

        mv1=sqrt(v1x*v1x+v1y*v1y);
        mv2=sqrt(v2x*v2x+v2y*v2y);

        theta = acos((v1x*v2x+v1y*v2y)/mv1/mv2);

        ct = cos(theta);
        st = sin(theta);


        printf("Current display buffer = %i\n",disbuf);

again:  source=disbuf;
        get_default_i("Enter source buffer (0,1) ",&source);

        if((source != 0 ) && (source != 1))
        {
                source = disbuf;
        }

        target=1-disbuf;
        get_default_i("Enter target buffer (0,1) ",&target);

        if((target != 0 ) && (target != 1))
        {
                target = 1-disbuf;
        }
        if(target == source )
        {
                printf("Source and target equal \n");
                goto again;
        }

        printf("Working ... \n");

        for(i=0;i<width;i++)
        {
                for(j=0;j<height;j++)
                {
                     putimage(target,j,i,0);
                }
        }

        for(i=0;i<width;i++)
        {
                for(j=0;j<height;j++)
                {
                        inew = x0 + (int)(dx + ct*(i-x0) + st*(j-y0)+.5);
                        jnew = y0 + (int)(dy - st*(i-x0) + ct*(j-y0)+.5);

                        if((inew < width) && (inew > -1) )
                        {
                          if((jnew < height) && (jnew > -1) )
                          {

                            putimage(target,jnew,inew,(int)image(source,j,i));

                           }
                         }

                }
        }

        disbuf=target;
        set_buffer();
        newimage=1;
        redraw();

        printf("Done        \n");
}


/*******************************************************************

              Utility routines

********************************************************************/

int get_pos(int *row,int *col)
{
int done,i;
char txt[20];
/*
        returns the position of  a mouse pointer click

        returns 1 if pointer clicked

        returns -1 if q pressed

        cursor changes to cross hair for input

        includes event loop with redraw for window 1 only

        clears the menu window (does not use it)
*/

        XClearWindow(mydisplay,my2window);
/*
         used to change cursor here

         cross_hair();

*/

        /* event-reading loop to get cursor position */
        done = 0;
        while( done == 0) {
                /* read the next event */
          XNextEvent(mydisplay, &myevent);

          if(myevent.xany.window == mywindow)
          {
                switch(myevent.type){
                        /* repaint window on expose events */
                        case Expose:

                              if(myevent.xexpose.count == 0) redraw();

                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
                        XRefreshKeyboardMapping(&myevent.xmapping);
                        break;

                        /* process mouse-button presses */
                        case ButtonPress:

                                    *col=myevent.xmotion.x;
                                    *row=myevent.xmotion.y;
                                    done = 1;

                        break;

                        /* process keyboard input */
                        case KeyPress:
                                i = XLookupString( &myevent.xkey, txt, 10, &mykey, 0);
                                if( i == 1 && txt[0] == 'q') done = -1;
                                printf("... aborted \n");
                        break;
                } /* switch(myevent.type) */

            } /* if == mywindow */

        } /* while(done == 0) */

        /* set cursor back -- now done external to this function

        XUndefineCursor(mydisplay,mywindow);
*/
        /* set menus back */

        draw_buttons();

        return(done);
}

cross_hair()
{
        /* set cursor to crosshair */
        mycursor = XCreateFontCursor(mydisplay,XC_crosshair);
         XFlush(mydisplay);
        XDefineCursor(mydisplay,mywindow,mycursor);
}

default_cursor()
{
        XUndefineCursor(mydisplay,mywindow);
}

get_default_i(char *prompt,int *x)
{
char temp[50];

        printf("%s <%i> ? ",prompt,*x);

        gets(temp);

        if (temp[0] != '\0' )
        {
                sscanf(temp,"%i",x);
        }

}

get_default_s(char *prompt,char *x)
{
char temp[50];

        printf("%s <%s> ? ",prompt,x);

        gets(temp);

        if (temp[0] != '\0' )
        {
                strcpy(x,temp);
        }

}

get_default_c(char *prompt,char *x)
{
char temp[50];

        printf("%s <%c> ? ",prompt,*x);

        gets(temp);

        if (temp[0] != '\0' )
        {
                *x = temp[0];
        }

}

get_default_f(char *prompt,float *x)
{
char temp[50];

        printf("%s <%.4g> ? ",prompt,*x);

        gets(temp);

        if (temp[0] != '\0' )
        {
                sscanf(temp,"%f",x);
        }

}

#ifdef LOGISCAN

open_scanner()
{
long hlp;

  if ((scan_fd = open("/dev/scan", O_RDONLY)) < 0) 
  {
    perror("open");
    frame_exit();
  }
  
  hlp=0;
  if ((ioctl(scan_fd, HSIOCSBUF, &hlp)) < 0) {
    perror("ioctl (SetBufLen) ");
    close(scan_fd);
    exit(2);
  }

  hlp=100;
  if ((ioctl(scan_fd, HSIOCSBUF, &hlp)) < 0) {
    perror("ioctl (SetBufLen) ");
    close(scan_fd);
    exit(2);
  }


}
int setup_scanner(void)
{ 
long hlp;
  
	open_scanner();
	
/*
  if ((ioctl(scan_fd, HSIOCGSCT, &sct)) < 0) {
    perror("ioctl (GetType) ");
    close(scan_fd);
    exit(2);
  }

  if ((ioctl(scan_fd, HSIOCGSCC, &scc)) < 0) {
    perror("ioctl (GetCapabilities) ");
    close(scan_fd);
    exit(2);
  }
*/
  if ((ioctl(scan_fd, HSIOCGMOD, &mi)) < 0) {
    perror("ioctl (GetMode) ");
    close(scan_fd);
    exit(2);
  }
/*
  if ((ioctl(scan_fd, HSIOCGOPT, &sco)) < 0) {
    perror("ioctl (GetOptions) ");
    close(scan_fd);
    exit(2);
  }
*/
  if (/* mi.sc_mode!=SCM_MONO&& */ mi.sc_mode!=SCM_GREY) {
    fprintf( stderr,"Unsupported mode %d \n",mi.sc_mode);
    close(scan_fd);
    exit(2);
  }

  if (mi.sc_mode==SCM_GREY) { 
    scan_graylevels=255;  /* We will get 256 colours */
    width = mi.right;
  }

  if(scan_buf != NULL) free(scan_buf);
  
  if ((scan_buf=malloc(mi.bpl))==NULL) {
    fprintf( stderr,"Cannot malloc(%d) for line-buffer ...\n",mi.bpl);
    close(scan_fd);
    exit(2);
  }

  hlp=0;
  if ((ioctl(scan_fd, HSIOCSBUF, &hlp)) < 0) {
    perror("ioctl (SetBufLen) ");
    close(scan_fd);
    exit(2);
  }

  hlp=100;
  if ((ioctl(scan_fd, HSIOCSBUF, &hlp)) < 0) {
    perror("ioctl (SetBufLen) ");
    close(scan_fd);
    exit(2);
  }

 
 close(scan_fd);
 
}


int get_scan_line(int *row)
{ 
int ret,r,retval,i,level,row2;
    
    	FD_ZERO(&rfds);
	FD_SET(scan_fd, &rfds);
	/* Wait up to SCAN_WAIT seconds. */
	tv.tv_sec = SCAN_WAIT;
	tv.tv_usec = 0;

	ret = select(1, &rfds, NULL, NULL, &tv);
   
      if(retval) /* we have data */
      {
     
      	if ((r = read(scan_fd, scan_buf, mi.bpl)) < 0) 
      	{
		perror("read");
		close(scan_fd);
		return(-1); /* error */
      	} 
      	else 
      	{
      		row2=*row;
      		for(i=0;i<width;i++)
      		{
      			level = (int)(*(scan_buf+i));
      			putimage(disbuf,row2, i,level);
      				
      			
      		}
      		*row=*row + 1;
      		return(r);
      
        }
      }
      else
      	return(0); /* no data */
    
  
}

do_scan()
{
char temp[100];
int row,i,r,level,oldwidth,answer;

	oldwidth = width;
	
        sprintf(question,"Change the vertical scan size?");
        set_buttons_question(1);
        draw_buttons();
        answer = get_answer();
	
	if(answer == 0)
	{
		get_default_i("Scan height in inches",&inches);
	}
	
        sprintf(question,"Scan in Image");
        menu1.num_buttons = 0;
        draw_buttons();
	
	setup_scanner();
	
	if(height != inches*mi.ydpi || oldwidth != width ) /* size has changed */	
	{
		height = inches*mi.ydpi;
		resize();
		newimage = 1;	
	
		XResizeWindow(mydisplay,mywindow,width,height);
	
	}

	open_scanner();
	
	XClearWindow(mydisplay,mywindow);
	XFlush(mydisplay);

	for(row=0;row<height;row++)
	{
	      	if ((r = read(scan_fd, scan_buf, mi.bpl)) < 0) 
      		{
			perror("read");
			close(scan_fd);
			frame_exit(); /* error */
      		} 
      		else 
      		{
      			for(i=0;i<width;i++)
      			{
      				level = (int)(*(scan_buf+i));

	      			XSetForeground(mydisplay,mygc,lut[level]);
      				XDrawPoint(mydisplay,mywindow,mygc,i,row);
 	    				
       				put_pix(row,i,level);
     			
      			}
      
		}

	}
	
	XSetForeground(mydisplay,mygc,myforeground);

	close(scan_fd);
	
	strcpy(contents[disbuf],"scan");

	strcpy(question,"");
	set_buffer();
	set_buttons(&i,&r);
	draw_buttons();
}

resize()
{
int sz;

        sz = (long) 2*(width+1)*(height+1);  /* add some extra to make sure */

	free(imagebuff);
	
        imagebuff = (unsigned char*) malloc((size_t) sz);

        if (imagebuff == NULL )
        {
                printf("Unable to allocate image buffer \n");
                frame_exit();
        }
        
        if( depth <= 8)
        {
                sz = (long)(width+2)*(height+2);
        }
         else
        {
                sz = (long)(width+2)*(height+2)*3;/* for 24 bit need 3 bytes/pix */

        }
         
      	XDestroyImage(myimage);
      	myimage = NULL;
      	xsize = width;
      	ysize = height;
         
        imagedata = (unsigned char*) malloc((size_t) sz);

        if(imagedata == NULL)
        {
                printf("unable to allocate ximage data memory \n");
                frame_exit();
        }
        
        strcpy(contents[0],"empty");
        strcpy(contents[1],"empty");
        
        blank(255);/* fill buffers with white */
        
}

#endif
